SystemOrganization addCategory: #'Xpf-Client-Tests'!
SystemOrganization addCategory: #'Xpf-Client-ProjectTalk'!
SystemOrganization addCategory: #'Xpf-Client-Helpers'!
SystemOrganization addCategory: #'Xpf-Client-AdminTool'!
SystemOrganization addCategory: #'Xpf-Client-Models'!
SystemOrganization addCategory: #'Xpf-Client-Proxies'!
SystemOrganization addCategory: #'Xpf-Client-Widgets'!

XpfRestTest subclass: #XpfModelToProxyTest
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfModelToProxyTest methodsFor: 'as yet unclassified' stamp: 'cs 3/18/2009 11:05'!
setUp
	| factory |
	super setUp.
	factory := XpfProxyRepository fromString: self class url.
	proxy := factory getAllProjects first! !

!XpfModelToProxyTest methodsFor: 'as yet unclassified' stamp: 'mig 4/1/2009 16:27'!
testReloadTitle

	| oldTitle |	
	oldTitle := testProject title.
	testProject title: 'Wow!!'.
	proxy repository reload.
	self should: proxy title = testProject title.! !

!XpfModelToProxyTest methodsFor: 'as yet unclassified' stamp: 'topa 3/4/2009 00:34'!
testTitle

	self should: proxy title = testProject title.
	
	proxy userStories with: testProject userStories do: 
		[:proxyUS :realUS |  self should: proxyUS title = realUS title].! !

XpfRestTest subclass: #XpfProxyTest
	instanceVariableNames: 'projectProxy userStoryProxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfProxyTest methodsFor: 'as yet unclassified' stamp: 'cs 3/18/2009 11:10'!
setUp

	| factory |
	super setUp.
	factory := XpfProxyRepository fromString: self class url.
	projectProxy := factory getAllProjects first.
	userStoryProxy := projectProxy userStories first.! !

!XpfProxyTest methodsFor: 'as yet unclassified' stamp: 'topa 4/3/2009 14:14'!
testUpdateOnAdd

	| projectTaskCount userStoryTaskCount aTask |
	userStoryTaskCount := testStory tasks size.
	projectTaskCount := testProject tasks size.
	aTask := userStoryProxy addNewTask: (Dictionary with: 'title' -> 'UpdateOnAddTask').
	self
		should: userStoryProxy project = projectProxy;
		should: aTask project = projectProxy;
		should: testStory tasks size = (userStoryTaskCount + 1);
		should: testProject tasks size = (projectTaskCount + 1);
		should: userStoryProxy tasks size = (userStoryTaskCount + 1);
		should: projectProxy tasks size = (projectTaskCount + 1).! !

PanelMorph subclass: #XpfElementListMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfElementListMorph class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 21:43'!
for: anXpfIteration

	^self new model: anXpfIteration! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/10/2009 20:45'!
buildList

	self subclassResponsibility! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 21:46'!
initialize

	super initialize.
	self		
		changeTableLayout;
		hResizing: #rigid;
		vResizing: #shrinkWrap;
		fillStyle: Color veryVeryLightGray;
		borderWidth: 0;
		listDirection: #topToBottom;
		layoutInset: 1;
		cellPositioning: #topLeft;
		cellInset: 4.! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 21:46'!
layoutChanged

	self owner ifNotNil: 
		[self owner owner extent: 1@1 + self owner owner extent.
		self owner owner extent: -1@-1 + self owner owner extent].
	super layoutChanged.! !

!XpfElementListMorph methodsFor: 'accessing' stamp: 'SR 4/11/2009 21:13'!
model

	^ model! !

!XpfElementListMorph methodsFor: 'accessing' stamp: 'SR 4/11/2009 22:24'!
model: anXpfIteration

	self model ifNotNil: [self model removeDependent: self].
	model := anXpfIteration.
	self
		removeAllMorphs;
		buildList.
	self model ifNotNil: [self model addDependent: self].! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 21:54'!
withScrollBars

	| scrollPane |
	scrollPane := ScrollPane new.
	scrollPane
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		fillStyle: Color veryVeryLightGray;
		borderWidth: 0;
		alwaysShowHScrollBar: false;
		alwaysShowVScrollBar: false.
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	scrollPane scroller addMorph: self.
	^ scrollPane! !

XpfElementListMorph subclass: #XpfTaskListMorph2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskListMorph2 methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:34'!
buildList

	| |
	self model ifNil: [^self].
	
	self model userStories do: [:us | us tasks do: [ :task |
		self addMorphBack: ((XpfTaskListEntryMorph for: task) width: self width -2)]].! !

!XpfTaskListMorph2 methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 21:41'!
update: aSymbol

	aSymbol = #tasks ifTrue: [
		self
			removeAllMorphs;
			buildList].
	super update: aSymbol.! !

XpfElementListMorph subclass: #XpfUserStoryListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfUserStoryListMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:24'!
buildList

	| |
	self model ifNil: [^self].
	
	self model userStories do: [:each |
		self addMorphBack: (XpfUserStoryListEntryMorph for: each)].
! !

!XpfUserStoryListMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 21:22'!
update: aSymbol

	aSymbol = #userStories ifTrue: [
		self
			removeAllMorphs;
			buildList].
	super update: aSymbol.! !

PanelMorph subclass: #XpfEntityMorphContent
	instanceVariableNames: 'model inEditMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

XpfEntityMorphContent subclass: #XpfEditButtons
	instanceVariableNames: 'acceptButton cancelButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfEditButtons class methodsFor: 'as yet unclassified' stamp: 'mfp 3/18/2009 15:06'!
defaultExtent
	
	^ 2@2! !

!XpfEditButtons methodsFor: 'accessing' stamp: 'mfp 3/19/2009 16:02'!
acceptButton

	^ acceptButton ifNil: [
		acceptButton := UITheme current
			newButtonIn: self
			for:  self
			getState: nil
			action: #changed:
			arguments: #(accepted)
			getEnabled: nil
			label: 'Accept'
			help: 'Clicking this button accepts the changes.']! !

!XpfEditButtons methodsFor: 'accessing' stamp: 'SR 3/19/2009 11:23'!
cancelButton

	^ cancelButton ifNil: [
		cancelButton := UITheme current
			newButtonIn: self
			for:  self
			getState: nil
			action: #changed:
			arguments: #(cancelled)
			getEnabled: nil
			label: 'Cancel'
			help: 'Clicking this button discards the changes.']
! !

!XpfEditButtons methodsFor: 'initialization' stamp: 'mfp 3/19/2009 16:03'!
initialize

	super initialize.
	
	self
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		addMorph: (UITheme current newRowIn: self for: { 
			(UITheme current newToolSpacerIn: self) hResizing: #spaceFill; vResizing: #rigid. 
			self acceptButton. 
			self cancelButton}) .! !

!XpfEntityMorphContent class methodsFor: 'as yet unclassified' stamp: 'mfp 3/17/2009 16:48'!
defaultExtent

	self subclassResponsibility.! !

!XpfEntityMorphContent class methodsFor: 'as yet unclassified' stamp: 'mfp 3/17/2009 16:23'!
forModel: anXpfEntity

	^ self basicNew
		model: anXpfEntity;
		initialize! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 15:30'!
accept! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 16:08'!
cancel! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 14:52'!
inEditMode
	^ inEditMode! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 14:52'!
inEditMode: anObject
	inEditMode := anObject! !

!XpfEntityMorphContent methodsFor: 'initialization' stamp: 'mfp 3/18/2009 15:38'!
initialize

	super initialize.
	self 
		inEditMode: false;
		layoutPolicy: TableLayout new;
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultExtent;
		fillStyle: Color transparent.! !

!XpfEntityMorphContent methodsFor: 'testing' stamp: 'mfp 3/19/2009 16:13'!
isEntityMorphContent

	^ true! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/17/2009 15:09'!
model

	^ model! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/17/2009 16:45'!
model: anXpfEntity

	self model ifNotNil: [self model removeDependent: self].
	model := anXpfEntity.
	self model addDependent: self.
	
	self update.! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'SR 4/10/2009 15:58'!
toggleEditMode

	self
		inEditMode: (self inEditMode not);
		update.
	! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 15:30'!
update! !

XpfEntityMorphContent subclass: #XpfEstimationContent
	instanceVariableNames: 'actual estimated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfEstimationContent class methodsFor: 'defaults' stamp: 'SR 3/19/2009 12:48'!
defaultExtent

	^ 100@30! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'SR 3/19/2009 11:40'!
accept

	self estimated accept.
	self actual accept.! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'mt 4/1/2009 16:55'!
actual
	^ actual ifNil: [
		actual := (UITheme current
		newTextEntryIn: self
		for: self model
		get: #timeActual
		set: #timeActual:
		class: Number
		getEnabled: nil
		help: 'Enter the actual time in hours.') maxLength: 3].! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'SR 3/19/2009 11:35'!
actual: anObject
	actual := anObject! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'SR 3/19/2009 11:39'!
cancel

	self estimated cancel.
	self actual cancel.! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'mt 4/1/2009 16:55'!
estimated

	^ estimated ifNil: [
		estimated := (UITheme current
		newTextEntryIn: self
		for: self model
		get: #timeEstimated
		set: #timeEstimated:
		class: Number
		getEnabled: nil
		help: 'Enter an estimation for the time in hours.') maxLength: 3].! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'SR 3/19/2009 11:35'!
estimated: anObject
	estimated := anObject! !

!XpfEstimationContent methodsFor: 'initialization' stamp: 'SR 3/19/2009 19:51'!
initialize

	super initialize.
	self
		addMorph: (UITheme current newRowIn: self for: {self estimated. self actual});
		update.! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'mt 4/1/2009 16:55'!
update

	super update.
	(self inEditMode notNil and: [self inEditMode])
		ifTrue: [ self actual enable. self estimated enable ]
		ifFalse: [ self actual disable. self estimated disable ] ! !

XpfEntityMorphContent subclass: #XpfResponsibleDeveloperContent
	instanceVariableNames: 'label takeResponisibilityButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfResponsibleDeveloperContent class methodsFor: 'as yet unclassified' stamp: 'SR 4/10/2009 15:54'!
defaultExtent

	^ 165@20! !

!XpfResponsibleDeveloperContent methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 15:38'!
alreadyResponsible

	self model responsibleDeveloper ifNil: [^ false].
	^ self model responsibleDeveloper id = self model currentUser id.! !

!XpfResponsibleDeveloperContent methodsFor: 'as yet unclassified' stamp: 'SR 4/10/2009 15:27'!
initialize

	super initialize.
	self
		addMorph: (self theme newColumnIn: self for: {
			self label.
			self takeResponisibilityButton});
		update.
	! !

!XpfResponsibleDeveloperContent methodsFor: 'accessing' stamp: 'SR 4/10/2009 15:50'!
label

	label ifNil: [
		label := self theme newLabelIn: self label: (self model responsibleDeveloper isNil
			ifTrue: ['Nobody']
			ifFalse: [self model responsibleDeveloper userName])].
	^ label! !

!XpfResponsibleDeveloperContent methodsFor: 'accessing' stamp: 'SR 4/10/2009 15:23'!
label: anObject

	label := anObject! !

!XpfResponsibleDeveloperContent methodsFor: 'accessing' stamp: 'SR 4/10/2009 15:45'!
takeResponisibilityButton

	takeResponisibilityButton ifNil: [
		takeResponisibilityButton := self theme newButtonIn: self for: self getState: nil action: #takeResponsibility arguments: nil getEnabled: nil label: 'Take responsibility' help: ''].
	^ takeResponisibilityButton! !

!XpfResponsibleDeveloperContent methodsFor: 'accessing' stamp: 'SR 4/10/2009 15:22'!
takeResponisibilityButton: anObject

	takeResponisibilityButton := anObject! !

!XpfResponsibleDeveloperContent methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 17:28'!
takeResponsibility

	self model responsibleDeveloper: self model currentUser.
	
	self label contents:self model responsibleDeveloper userName.
	self takeResponisibilityButton visible: false.
	self extent: 165@20.
	
	self changed.! !

!XpfResponsibleDeveloperContent methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:58'!
toggleEditMode

	super toggleEditMode.	
	(self inEditMode notNil and: [self inEditMode])
		ifTrue: [
			self alreadyResponsible ifFalse: [
				self takeResponisibilityButton visible: true.
				self extent: 165@40]]
		ifFalse: [
			self takeResponisibilityButton visible: false.
			self extent: 165@20].! !

XpfEntityMorphContent subclass: #XpfTasksContent
	instanceVariableNames: 'taskList addButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTasksContent class methodsFor: 'defaults' stamp: 'mfp 3/19/2009 16:54'!
defaultExtent

	^ 200@150! !

!XpfTasksContent methodsFor: 'initialization' stamp: 'mfp 3/19/2009 16:58'!
addButton

	^ addButton ifNil: [
		addButton := UITheme current
			newButtonIn: self
			for:  self
			getState: nil
			action: #addTask
			arguments: #()
			getEnabled: nil
			label: '+'
			help: 'Click this button to add a new task.']! !

!XpfTasksContent methodsFor: 'actions' stamp: 'mfp 3/19/2009 17:00'!
addTask

	self model addNewTask: (Dictionary newFrom: {
		'title' -> nil.
		'explanation' -> nil.
		'timeEstimated' -> nil.
		'timeActual' -> nil}).
	self taskList update: nil.! !

!XpfTasksContent methodsFor: 'initialization' stamp: 'SR 3/19/2009 21:54'!
initialize

	super initialize.
	self 
		addMorph: self taskList withScrollBars;
		addMorph: self addButton.! !

!XpfTasksContent methodsFor: 'accessing' stamp: 'SR 3/19/2009 21:57'!
taskList

	taskList ifNil: [
		taskList := XpfTaskListMorph new model: self model.
		taskList height: self height.
		taskList width: self width - 20].
	^ taskList! !

!XpfTasksContent methodsFor: 'accessing' stamp: 'mfp 3/19/2009 16:27'!
taskList: anObject

	taskList := anObject.! !

XpfEntityMorphContent subclass: #XpfTitleContent
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

XpfTitleContent subclass: #XpfTaskTitleContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTaskTitleContent class methodsFor: 'defaults' stamp: 'SR 3/19/2009 21:23'!
defaultExtent
	^ 165@30! !

!XpfTaskTitleContent methodsFor: 'testing' stamp: 'SR 3/19/2009 21:18'!
isXpfTaskTitleContent
	^ true! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 15:15'!
accept

	self title accept.! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 16:08'!
cancel

	self title cancel.! !

!XpfTitleContent methodsFor: 'initialization' stamp: 'mfp 3/18/2009 16:04'!
initialize

	super initialize.
	self
		addMorph: self title;
		update. "lock first"! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'topa 4/1/2009 16:20'!
title

	title ifNil: [
		title := (UITheme current
			newTextEntryIn: self
			for: self model
			get: #title
			set: #title:
			class: String
			getEnabled: nil
			help: 'Enter a short descriptive title.') maxLength: 100].
	^ title
! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'mfp 3/17/2009 15:21'!
title: anObject

	title := anObject.! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 15:57'!
update
	super update.
	
	(self inEditMode notNil and: [self inEditMode])
		ifTrue: [ self title enable ]
		ifFalse: [ self title disable ] 
! !

XpfTitleContent subclass: #XpfUserStoryTitleContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryTitleContent class methodsFor: 'defaults' stamp: 'SR 3/19/2009 21:18'!
defaultExtent

	^ 200@100! !

!XpfUserStoryTitleContent methodsFor: 'testing' stamp: 'SR 3/19/2009 21:18'!
isXpfUserStoryTitleContent
	^ true! !

XpfEntityMorphContent subclass: #XpfTitleExplanationContent
	instanceVariableNames: 'title explanation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

XpfTitleExplanationContent subclass: #XpfTaskTitleExplanationContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTaskTitleExplanationContent class methodsFor: 'defaults' stamp: 'SR 3/19/2009 21:25'!
defaultExtent
	^ 165@60! !

!XpfTitleExplanationContent methodsFor: 'accessing' stamp: 'mfp 3/17/2009 17:05'!
accept
	
	self explanation accept.
	self title accept.! !

!XpfTitleExplanationContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 18:22'!
cancel

	self title cancel.
	self explanation cancel.! !

!XpfTitleExplanationContent methodsFor: 'accessing' stamp: 'mt 3/30/2009 16:09'!
explanation

	explanation ifNil: [
		explanation := PluggableTextMorph
			on: self model
			text: #explanation
			accept: #explanation:
		
		"UITheme current
			newTextEditorIn: self
			for: self model
			getText: #explanation
			setText: #explanation:
			getEnabled: nil.
		explanation
			spaceFillWeight: 2;
			hResizing: #rigid;
			width: 180"].
	^ explanation! !

!XpfTitleExplanationContent methodsFor: 'accessing' stamp: 'mfp 3/17/2009 16:51'!
explanation: anObject

	explanation := anObject.! !

!XpfTitleExplanationContent methodsFor: 'initialization' stamp: 'SR 3/19/2009 19:55'!
initialize

	super initialize.
	self
		addMorph: (UITheme current newColumnIn: self for: {self title. self explanation});
		update.! !

!XpfTitleExplanationContent methodsFor: 'accessing' stamp: 'topa 4/1/2009 16:21'!
title

	title ifNil: [
		title := UITheme current
			newTextEntryIn: self
			for: self model
			get: #title
			set: #title:
			class: String
			getEnabled: nil
			help: 'Enter a short description.'].
	^ title! !

!XpfTitleExplanationContent methodsFor: 'accessing' stamp: 'mfp 3/17/2009 16:51'!
title: anObject

	title := anObject.! !

!XpfTitleExplanationContent methodsFor: 'accessing' stamp: 'mt 3/30/2009 16:10'!
update

	super update.	
	(self inEditMode notNil and: [self inEditMode])
		ifTrue: [ self title enable. "self explanation enable" ]
		ifFalse: [ self title disable. "self explanation disable" ] ! !

XpfTitleExplanationContent subclass: #XpfUserStoryTitleExplanationContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryTitleExplanationContent class methodsFor: 'as yet unclassified' stamp: 'SR 3/19/2009 21:25'!
defaultExtent

	^ 200@200! !

XpfEntityMorphContent subclass: #XpfWorkTimerContent
	instanceVariableNames: 'startStopButton startTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfWorkTimerContent class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 23:06'!
defaultExtent

	^ 165@20! !

!XpfWorkTimerContent methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 17:33'!
initialize

	super initialize.
	self
		addMorph: self startStopButton;
		update.! !

!XpfWorkTimerContent methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:33'!
startStopButton

	startStopButton ifNil: [
		self startStopButton: (self theme newButtonIn: self for: self getState: nil action: #toggleStartStop arguments: nil getEnabled: nil label: 'Start' help: '')].
	^ startStopButton! !

!XpfWorkTimerContent methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:29'!
startStopButton: anObject

	startStopButton := anObject! !

!XpfWorkTimerContent methodsFor: 'accessing' stamp: 'SR 4/11/2009 23:04'!
startTime

	^ startTime! !

!XpfWorkTimerContent methodsFor: 'accessing' stamp: 'SR 4/11/2009 23:04'!
startTime: anObject

	startTime := anObject! !

!XpfWorkTimerContent methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 18:14'!
startTimer

	| secondDeveloper |
	secondDeveloper := (World openModal: (XpfDeveloperChooser for: self model)) result.
	secondDeveloper ifNil: [^self].

	self model addDeveloper: self model currentUser.
	self model addDeveloper: secondDeveloper.
	self startTime: Time now.

	self startStopButton label: 'Stop'! !

!XpfWorkTimerContent methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 18:14'!
stopTimer

	| delta |
	delta := Timespan starting: self startTime ending: Time now.
	(self theme questionWithoutCancelIn: self text: 'Add the ',delta duration hours asString,'hrs to actual time?' title: 'XPForums ProjectTalk') ifTrue: [
		self model timeActual: (self model timeActual + delta duration hours)	].
	self startTime: nil.
	self startStopButton label: 'Start'.! !

!XpfWorkTimerContent methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 18:14'!
toggleStartStop

	self startTime isNil
		ifTrue: [self startTimer]
		ifFalse: [self stopTimer].! !

XpfEntityMorphContent subclass: #XpfZoomButtons
	instanceVariableNames: 'zoomButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfZoomButtons class methodsFor: 'as yet unclassified' stamp: 'mfp 3/18/2009 18:15'!
defaultExtent
	
	^ 2@2! !

!XpfZoomButtons class methodsFor: 'as yet unclassified' stamp: 'topa 3/23/2009 11:07'!
downArrowFrom

	^ ScrollBar arrowOfDirection: #bottom size: 24 color: Color lightGray! !

!XpfZoomButtons class methodsFor: 'as yet unclassified' stamp: 'topa 3/23/2009 11:07'!
rightArrowFrom

	^ ScrollBar arrowOfDirection: #right size: 24 color: Color lightGray! !

!XpfZoomButtons methodsFor: 'initialization' stamp: 'SR 3/19/2009 20:34'!
initialize

	super initialize.
	
	self
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		addMorph: (UITheme current newRowIn: self for: { 
			self zoomButton. 
			(UITheme current newToolSpacerIn: self) hResizing: #spaceFill; 				vResizing: #rigid. }) ! !

!XpfZoomButtons methodsFor: 'as yet unclassified' stamp: 'topa 3/23/2009 10:58'!
toggleZoom

	self owner inZoomMode
		ifTrue: [
			self changed: #zoomOut.
			self zoomButton labelGraphic: self class rightArrowFrom]
		ifFalse: [
			self changed: #zoomIn.
			self zoomButton labelGraphic: self class downArrowFrom].! !

!XpfZoomButtons methodsFor: 'accessing' stamp: 'topa 3/23/2009 11:07'!
zoomButton

	zoomButton ifNil: [
		zoomButton :=  IconicButton new
	 		color: Color transparent;
		 	target: self;
		 	borderWidth: 0;
			labelGraphic: self class rightArrowFrom;
			actionSelector: #toggleZoom;
			setBalloonText: 'zoom' translated].
	^ zoomButton! !

!XpfZoomButtons methodsFor: 'accessing' stamp: 'SR 3/19/2009 20:32'!
zoomButton: anObject
	zoomButton := anObject! !

PanelMorph subclass: #XpfHistoryEntryMorph
	instanceVariableNames: 'model entityTypeField timeField entityTitleField actionField detailField userField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfHistoryEntryMorph class methodsFor: 'as yet unclassified' stamp: 'cs 4/7/2009 14:22'!
forEntry: anXpfHistoryEntryModel

	^ self basicNew
		model: anXpfHistoryEntryModel;
		initialize! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:54'!
actionField

	actionField ifNil: [
		self actionField:
			((self model entry at: #action) asMorph
			emphasis: 1;
			hResizing: #rigid;
			width: 65)].
	^ actionField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:57'!
actionField: anObject

	actionField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 16:44'!
detailField

	detailField ifNil: [
		self detailField:
			(self detailsText asMorph
			hResizing: #spaceFill)].
	^ detailField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
detailField: anObject

	detailField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'cs 4/7/2009 18:10'!
detailsText

	(self model entry at: #action) = #created ifTrue: [^ ''].
	(self model entry at: #action) = #deleted ifTrue: [^ ''].
	(self model entry at: #action) = #added ifTrue: [^ self detailsTextAdded].
	(self model entry at: #action) = #changed ifTrue: [^ self detailsTextChanged].
	^ ''! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'cs 4/8/2009 10:53'!
detailsTextAdded

	^ (self model entry at: #new) asText
		"addAttribute: TextEmphasis underlined;"
		append: ' to ';
		append: (self model entry at: #property) capitalized asText allBold;
		yourself! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'cs 4/8/2009 11:55'!
detailsTextChanged

	| result |
	result := (self model entry at: #property) asText allBold.
	(self model entry at: #old) ifNotNil:
		[result
			append: ' from ';
			append: ((self model entry at: #old) asString asText addAttribute: TextEmphasis italic; yourself)].
	result
		append: ' to ';
		append: ((self model entry at: #new) asString asText addAttribute: TextEmphasis italic; yourself);
		yourself.
	^ result! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 10:50'!
entityTitleField

	entityTitleField ifNil: [self entityTitleField: 
		(UpdatingStringMorph new
			target: self model entity;
			getSelector: #title;
			useStringFormat;
			"emphasis: 4(self model entity isDeleted ifTrue: [20] ifFalse: [4]);"
			hResizing: #rigid;
			width: 120)].
		
	^ entityTitleField ! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
entityTitleField: anObject

	entityTitleField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:53'!
entityTypeField

	entityTypeField ifNil: [
		self entityTypeField:
			(self model entityType asString capitalized asMorph
			color: Color darkGray;
			hResizing: #rigid;
			width: 50)].
	^ entityTypeField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
entityTypeField: anObject

	entityTypeField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'initialization' stamp: 'cs 4/8/2009 11:54'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color white;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 8;
		initializeFields.! !

!XpfHistoryEntryMorph methodsFor: 'initialization' stamp: 'cs 4/7/2009 18:14'!
initializeFields

	self
		addMorphBack: self timeField;
		addMorphBack: self entityTypeField;
		addMorphBack: self entityTitleField;
		addMorphBack: self actionField;
		addMorphBack: self detailField.
	(self model entry at: #user) ifNotNil:
		[self addMorphBack: self userField].! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:57'!
model

	^ model! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:57'!
model: anObject

	model := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 16:34'!
timeField

	timeField ifNil: [
		self timeField:
			((self model entry at: #timestamp) asMorph
			emphasis: 2;
			hResizing: #rigid;
			width: 180)].
	^ timeField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
timeField: anObject

	timeField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 18:32'!
userField

	userField ifNil: [
		self userField:
			(self userText asMorph
				color: Color darkGray;
				hResizing: #rigid;
				width: 120)].
	^ userField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:48'!
userField: anObject

	userField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'cs 4/7/2009 18:30'!
userText

	^ (self model entry at: #user) asText
		addAttribute: TextEmphasis underlined;
		prepend: 'by ';
		yourself! !

PanelMorph subclass: #XpfHistoryMorph
	instanceVariableNames: 'model table checkboxBar projectCheckbox userStoriesCheckbox tasksCheckbox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfHistoryMorph class methodsFor: 'as yet unclassified' stamp: 'cs 4/7/2009 11:03'!
forProject: anXpfProject

	^ self basicNew
		model: (XpfHistoryModel new project: anXpfProject);
		initialize! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:32'!
checkboxBar

	checkboxBar ifNil: [self checkboxBar:
		(UITheme current newRowIn: self for: {
			'Show history for: ' asMorph.
			self projectCheckbox.
			self userStoriesCheckbox.
			self tasksCheckbox})].
	
	^ checkboxBar! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:36'!
checkboxBar: anObject

	checkboxBar := anObject.! !

!XpfHistoryMorph methodsFor: 'initialization' stamp: 'cs 4/7/2009 11:39'!
initialize

	super initialize.
	self
		visible: false;
		disableTableLayout: true;
		height: 100;
		vResizing: #rigid;
		hResizing: #spaceFill;
		changeTableLayout;
		addMorph: self table;
		addMorph: self checkboxBar.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:11'!
model

	^ model! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 10:55'!
model: anObject

	model := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 18:23'!
projectCheckbox

	projectCheckbox ifNil: [self projectCheckbox: 
		(UITheme current newCheckboxIn: self
		for: self model
		getSelected: #showProject
		setSelected: #showProject:
		getEnabled: nil
		label: 'Project'  
		help: 'Check this box to see history details on project level')].
	
	^ projectCheckbox
	  ! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 10:55'!
projectCheckbox: anObject

	projectCheckbox := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:51'!
table

	table ifNil: [self table:
		((UITheme current 
			newMorphListIn: self
			for: self model
			list: #entriesAsMorphs
			getSelected: nil
			setSelected: nil
			getEnabled: nil
			help: 'Shows the project history')
			height: 80;
			vResizing: #rigid;
			hResizing: #spaceFill)].
	^ table! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 10:55'!
table: anObject

	table := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:30'!
tasksCheckbox

	tasksCheckbox ifNil: [self tasksCheckbox: 
		(UITheme current newCheckboxIn: self
		for: self model
		getSelected: #showTasks
		setSelected: #showTasks:
		getEnabled: nil
		label: 'Tasks'
		help: 'Check this box to see history details on task level')].

	^ tasksCheckbox! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:29'!
tasksCheckbox: anObject

	tasksCheckbox := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:31'!
userStoriesCheckbox

	userStoriesCheckbox ifNil: [self userStoriesCheckbox: 
		(UITheme current newCheckboxIn: self
		for: self model
		getSelected: #showUserStories
		setSelected: #showUserStories:
		getEnabled: nil
		label: 'User Stories'  
		help: 'Check this box to see history details on User Story level')].

	^ userStoriesCheckbox! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:29'!
userStoriesCheckbox: anObject

	userStoriesCheckbox := anObject.! !

PanelMorph subclass: #XpfIterationSidebarMorph
	instanceVariableNames: 'model selectedTitle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/7/2009 20:44'!
click: anXpfIteration with: anEvent from: anExpanderTitleMorph

	anEvent redButtonChanged ifTrue: [
		self selectIteration: anXpfIteration with: anEvent from: anExpanderTitleMorph.
		anEvent wasHandled: true].
	anEvent yellowButtonChanged ifTrue: [
		self openContextPopupMenu: anXpfIteration with: anExpanderTitleMorph..
		anEvent wasHandled: true].! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/7/2009 20:43'!
editName: anXpfIteration with: anExpanderTitleMorph

	| answer |
	answer := ((UITheme current) textEntryIn: self text: 'Enter iteration name:' title: 'XPF-Client' entryText: anXpfIteration title).
	answer ifNotNil: [
		anXpfIteration title: answer.
		anExpanderTitleMorph titleText: anXpfIteration title].! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'SR 4/10/2009 12:51'!
fill

	self model iterations do: [:iteration | |expander|
			expander := (UITheme current
				newExpanderIn: self
				label: (iteration title ifNil: [''])
				forAll: {XpfIterationTreeMorph for: iteration}).
			expander titleMorph on: #mouseUp send: #click:with:from: to: self withValue: iteration.
			self addMorph: expander.
			expander titleMorph addDependent: self].
	
	self submorphs size > 1 ifTrue: [ | expander tree |
		expander := self submorphs second expanded: true.
		tree := expander submorphs detect: [:m | m ~= expander titleMorph].
		self selectIteration: tree model iteration with: nil from: expander titleMorph].! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'mt 4/1/2009 13:54'!
initialize

	super initialize.
	
	self
		layoutPolicy: TableLayout new;
		hResizing: #rigid;
		vResizing: #spaceFill;
		extent: 200@700.! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'mfp 3/26/2009 12:47'!
model

	^ model! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'mt 4/1/2009 16:10'!
model: anXpfProject

	model := anXpfProject.
	model addDependent: self.
	self fill.! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/7/2009 20:54'!
openContextPopupMenu: anXpfIteration with: anExpanderTitleMorph
	
	| menu |
	menu := MenuMorph new.
	menu addTitle: 'Iteration'.
	menu add: 'Edit name' target: self selector: #editName:with: argumentList: (Array with:anXpfIteration with: anExpanderTitleMorph)..
	menu add: 'Remove' target: self selector: #removeIteration: argument: anXpfIteration.
	menu popUpInWorld.! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/7/2009 21:08'!
removeIteration: anXpfIteration

	anXpfIteration isXpfFutureIteration ifFalse: [
		((UITheme current) proceedIn: self text: 'Are you shure?' title: 'Proceed') ifTrue: [
			self model removeIteration: anXpfIteration.
		].
	]! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'mt 4/1/2009 14:08'!
selectIteration: anXpfIteration with: evt from: anExpanderTitleMorph 

	anXpfIteration isXpfFutureIteration 
		ifTrue: [self changed: #toggleFuturePoolRequested]
		ifFalse: [
			self changed: #iterationSelected with: anXpfIteration.
			self selectedTitle: anExpanderTitleMorph; updateHighlight].! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'mt 4/1/2009 14:07'!
selectedTitle
	^ selectedTitle! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'mt 4/1/2009 14:07'!
selectedTitle: anObject
	selectedTitle := anObject! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'mt 4/1/2009 14:10'!
setHighlightAt: anExpanderTitleMorph 

	anExpanderTitleMorph ifNil: [^ self].
	
	self submorphsDo: [:morph | 
		(morph isKindOf: ExpanderMorph) ifTrue: [
			morph titleMorph fillStyle:
				(UITheme current expanderTitleNormalFillStyleFor: morph titleMorph)]].
	anExpanderTitleMorph fillStyle: 
		(anExpanderTitleMorph fillStyle mixed: 3/4 with: Color green)! !

!XpfIterationSidebarMorph methodsFor: 'updating' stamp: 'SR 4/9/2009 08:45'!
update: aSymbol

	super update: aSymbol.
	self updateHighlight.

	aSymbol = #iterations ifTrue: [ self removeAllMorphs. self fill].
	! !

!XpfIterationSidebarMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 14:12'!
updateHighlight

	self setHighlightAt: self selectedTitle.! !

PanelMorph subclass: #XpfListWidget
	instanceVariableNames: 'model iterationList elementList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfListWidget class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 21:55'!
defaultExtent

	^ 200@500! !

!XpfListWidget class methodsFor: 'as yet unclassified' stamp: 'SR 4/10/2009 19:25'!
elementListClass

	self subclassResponsibility! !

!XpfListWidget class methodsFor: 'instance creation' stamp: 'SR 4/10/2009 19:37'!
open
	
	| instance login |
	[login := XpfLoginProcessor new.
	
	Utilities informUserDuring: [:bar |
		#(model open) do: [:step |
			step = #model ifTrue: [
				bar value: 'Preparing data...'.
				instance := self new model: login project].
			step = #open ifTrue: [
				bar value: 'Opening widget...'.
				instance openInHand]]].

	^ instance]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfListWidget methodsFor: 'accessing' stamp: 'SR 4/10/2009 20:33'!
elementList

	elementList ifNil: [
		self elementList: (self class elementListClass new).
		self elementList
			hResizing: #spaceFill;
			vResizing: #spaceFill].
	^ elementList! !

!XpfListWidget methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:14'!
elementList: anObject

	elementList := anObject! !

!XpfListWidget methodsFor: 'initialization' stamp: 'SR 4/11/2009 22:00'!
initialize

	super initialize.
	self
		extent: self class defaultExtent;
		hResizing: #rigid;
		initializeUserInterface.! !

!XpfListWidget methodsFor: 'initialization' stamp: 'SR 4/11/2009 22:49'!
initializeUserInterface

	self
		"useRoundedCorners;"
		changeTableLayout;
		fillStyle: Color blue.
	self addMorph: ((self theme newColumnIn: self for: {self iterationList. self elementList withScrollBars.})
			hResizing: #spaceFill;
			vResizing: #spaceFill).
	self elementList extent: self elementList extent.! !

!XpfListWidget methodsFor: 'accessing' stamp: 'SR 4/10/2009 20:09'!
iterationList

	iterationList ifNil: [
		self iterationList: (self theme
							newDropListIn: self
							for: (XpfIterationListModel new project: self model)
							list: #list
							getSelected: #selectionIndex
							setSelected: #selectionIndex:
							getEnabled: nil
							useIndex: true
							help: '').
		self iterationList hResizing: #spaceFill.
		self iterationList model addDependent: self.].
	^ iterationList! !

!XpfListWidget methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:14'!
iterationList: anObject

	iterationList := anObject! !

!XpfListWidget methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:08'!
model

	^ model! !

!XpfListWidget methodsFor: 'accessing' stamp: 'SR 4/11/2009 22:50'!
model: aXpfProject

	model := aXpfProject.
	self iterationList model project: self model.
	self iterationList listSelectionIndex: 2.
	
	self elementList extent: self elementList extent.! !

!XpfListWidget methodsFor: 'as yet unclassified' stamp: 'SR 4/10/2009 20:09'!
update: aSymbol

	aSymbol = #selectionIndex ifTrue: [| newIteration |
		newIteration := self iterationList model iteration.
		self elementList model: newIteration].
	^super update: aSymbol.! !

XpfListWidget subclass: #XpfTaskListWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskListWidget class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:01'!
elementListClass

	^ XpfTaskListMorph2! !

XpfListWidget subclass: #XpfUserStoryListWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfUserStoryListWidget class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 21:56'!
elementListClass

	^ XpfUserStoryListMorph! !

XpfTestCase subclass: #XpfAdminToolTest
	instanceVariableNames: 'sut factoryMock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfAdminToolTest methodsFor: 'setup' stamp: 'cs 3/18/2009 11:05'!
setUp
	super setUp.
	sut := XpfAdminTool new.
	factoryMock := XpfProxyRepositoryMock new.
	sut initializeWith: factoryMock.
	sut projectList selectionIndex: 1.
	sut projectList changeModelSelection: sut projectList selectionIndex.
	sut userList selectionIndex: 1.
	sut userList changeModelSelection: sut userList selectionIndex! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/6/2009 16:07'!
testAddDeveloperToProject
	
	sut projectList selectionIndex: 1.
	sut projectList changeModelSelection: sut projectList selectionIndex.
	
	self
		should: factoryMock getAllProjects first developers size = 0;
		should: sut projectDeveloperList getList size = 0;
		should: sut projectUserDropList listMorph getList size = 2.
	
	sut projectUserDropList listSelectionIndex: 2.
	sut projectAddDeveloperButton performAction.
	
	self
		should: factoryMock getAllProjects first developers size = 1;
		should: factoryMock getAllProjects first developers first = factoryMock getAllUsers second;
		should: sut projectDeveloperList getList size = 1;
		should: sut projectUserDropList listMorph getList size = 1.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'cs 3/9/2009 10:35'!
testAddProject
	
	| projectCount |
	projectCount := sut model projects size.
	sut projectAddButton performAction.
	
	self
		should: sut model projects size = (projectCount + 1);
		should: sut projectList selection = 'New Project'.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'cs 3/9/2009 10:35'!
testAddUser
	
	| userCount |
	userCount := sut model users size.
	sut userAddButton performAction.
	
	self
		should: sut model users size = (userCount + 1);
		should: sut userList selection = 'New User'.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/5/2009 13:43'!
testDeleteProject
	
	| projectCount projectTitle |
	projectCount := sut model projects size.
	sut projectList changeModelSelection: 1.
	projectTitle := sut projectList selection.
	sut projectDeleteButton performAction.
	
	self
		should: sut model projects size = (projectCount - 1);
		should: sut projectList selectionIndex = 1;
		shouldnt: sut projectList selection = projectTitle.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/5/2009 13:44'!
testDeleteUser
	
	| userCount userName |
	userCount := sut model users size.
	sut userList changeModelSelection: 1.
	userName := sut userList selection.
	sut userDeleteButton performAction.
	
	self
		should: sut model users size = (userCount - 1);
		should: sut userList selectionIndex = 1;
		shouldnt: sut userList selection = userName.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/4/2009 13:40'!
testEditProjectTitle
	
	sut projectTitleEntry setText: 'testEditProjectTitle'.
	sut saveProjectButton performAction.
	
	self
		should: sut projectList selection = 'testEditProjectTitle';
		should: sut model projects first title = 'testEditProjectTitle'.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/4/2009 14:53'!
testEditUserLogin
	
	sut userLoginEntry setText: 'testEditUserLogin'.
	sut saveUserButton performAction.
	
	self
		should: sut userList selection = sut model users first userName;
		should: sut model users first login = 'testEditUserLogin'.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/4/2009 14:52'!
testEditUserName
	
	sut userNameEntry setText: 'testEditUserName'.
	sut saveUserButton performAction.
	
	self
		should: sut userList selection = 'testEditUserName';
		should: sut model users first userName = 'testEditUserName'.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/6/2009 14:36'!
testGetAllProjects
	
	self
		should: sut projectList getList size = 2;
		should: sut projectList getList first = factoryMock getAllProjects first title;
		should: sut projectList getList second = factoryMock getAllProjects second title.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/5/2009 13:44'!
testGetAllUsers
	
	self
		should: sut userList getList size = 2;
		should: sut userList getList first = factoryMock getAllUsers first userName.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'cs 3/9/2009 15:42'!
testRemoveDeveloperFromProject
	
	sut projectList selectionIndex: 2.
	sut projectList changeModelSelection: sut projectList selectionIndex.
	
	self
		should: factoryMock getAllProjects second developers size = 2;
		should: sut projectDeveloperList getList size = 2;
		should: sut projectUserDropList listMorph getList size = 0.
	
	sut projectDeveloperList selectionIndex: 1.
	sut projectDeveloperList changeModelSelection: sut projectDeveloperList selectionIndex.
	sut projectDeleteDeveloperButton performAction.
	self
		should: factoryMock getAllProjects second developers size = 1;
		should: sut projectDeveloperList getList size = 1;
		should: sut projectUserDropList listMorph getList size = 1.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/6/2009 14:38'!
testSelectProject
	
	sut projectList selection: factoryMock projectTitle.
	sut projectList changeModelSelection: sut projectList selectionIndex.
	
	self
		should: sut projectList selectionIndex = 2;
		should: sut projectTitleEntry text = factoryMock projectTitle;
		should: sut projectDeveloperList getList size = 2;
		should: sut projectDeveloperList getList first = factoryMock getAllUsers first userName;
		should: sut projectDeveloperList getList second = factoryMock getAllUsers second userName.
		! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/6/2009 13:30'!
testSelectUser
	
	sut userList selection: factoryMock userName.
	sut userList changeModelSelection: sut userList selectionIndex.
	
	self
		should: sut userList selectionIndex = 2;
		should: sut userNameEntry text = factoryMock userName;
		should: sut userLoginEntry text = factoryMock userLogin.! !

XpfTestCase subclass: #XpfChangePasswordTest
	instanceVariableNames: 'user sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfChangePasswordTest methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 14:48'!
setUp

	super setUp.
	user := XpfUser newFrom:
		(Dictionary newFrom:
			{'login' -> 'bernd'.
			'password' -> 'secret'}).
	sut := XpfChangePasswordModel new.	
	sut user: user.! !

!XpfChangePasswordTest methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 14:48'!
testChangePassword

	sut newPassword: 'delta'.
	sut newPasswordRepeat: 'delta'.
	sut accept.
	self should: (user authenticateBy: 'delta').! !

!XpfChangePasswordTest methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 14:49'!
testInvalidRepeatPassword

	sut newPassword: 'delta'.
	sut newPasswordRepeat: 'delta23'.
	sut accept.
	self
		shouldnt: (user authenticateBy: 'delta');
		shouldnt: (user authenticateBy: 'delta23').! !

XpfTestCase subclass: #XpfClientTest
	instanceVariableNames: 'project iteration1 userstory1 userstory2 sut task1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfClientTest methodsFor: 'running' stamp: 'mt 3/31/2009 16:14'!
setUp

	super setUp.
	self setupFixtures.
	sut := XpfClient new model: project.
! !

!XpfClientTest methodsFor: 'running' stamp: 'mig 4/1/2009 11:10'!
setupFixtures

	project := XpfProject new title: 'Test Project'.
	iteration1 := XpfIteration new
		title: 'Sample Iteration'.
	userstory1 := XpfUserStory new
		title: 'Test User Story with long title.';
		explanation: 'This is the explanantion of a user story.'.
	userstory2 := XpfUserStory new title: 'Test User Story'.
	task1 := XpfTask new 
		title: 'Test Task';
		explanation: 'This is the explanantion of a task.'.
	project
		addUserStory: userstory1;
		addUserStory: userstory2;
		addIteration: iteration1.
	iteration1
		addUserStory: userstory1.
	userstory1 addTask: task1.! !

!XpfClientTest methodsFor: 'running' stamp: 'mt 3/12/2009 13:39'!
tearDown

	project
		removeUserStory: userstory1;
		removeUserStory: userstory2.
		
	super tearDown.! !

!XpfClientTest methodsFor: 'tests' stamp: 'mfp 3/19/2009 17:23'!
testAddTask

	| sut2 taskCount taskMorphCount|
	sut2 := XpfTasksContent forModel: userstory1.
	taskCount := userstory1 tasks size.
	taskMorphCount :=  sut2 taskList submorphs size.

	self should: (sut2 taskList submorphs first isKindOf: XpfTaskMorph).

	sut2 addTask.	
	self
		should: sut2 taskList submorphs size = (taskMorphCount + 1);
		should: (sut2 taskList submorphs first isKindOf: XpfTaskMorph);
		should: (sut2 taskList submorphs second isKindOf: XpfTaskMorph);
		should: userstory1 tasks size = (taskCount + 1).! !

!XpfClientTest methodsFor: 'tests' stamp: 'mfp 3/19/2009 15:35'!
testAddUSMorphsToProjectMorph

	| usMorphCount projectMorph |
	projectMorph := XpfUserStoryPoolMorph new.
	usMorphCount := projectMorph userStorySubmorphs size.

	projectMorph 
		addUserStoryMorph: (XpfUserStoryMorph forUserStory: userstory1).
	self should: projectMorph userStorySubmorphs size = (usMorphCount + 1)! !

!XpfClientTest methodsFor: 'tests' stamp: 'topa 3/4/2009 00:32'!
testProjectTitleDisplay

 	self should: sut label = project printString.! !

!XpfClientTest methodsFor: 'tests' stamp: 'SR 3/19/2009 21:29'!
testUserStoryTextContent
	| sut2 titleMorph |
	sut2 := XpfUserStoryMorph forUserStory: userstory2.
	self should: sut2 submorphCount > 0.
	titleMorph := (sut2 submorphs detect: 
					[:submorph | 
					submorph isXpfUserStoryTitleContent and: 
							[submorph title getText asString = ('{1}' format: {  (userstory2 title)})]]) 
				title.
	self
		shouldnt: titleMorph isNil;
		should: titleMorph width <= XpfUserStoryTitleContent defaultExtent x! !

XpfTestCase subclass: #XpfHistoryTest
	instanceVariableNames: 'project userStory task sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfHistoryTest methodsFor: 'running' stamp: 'cs 4/8/2009 11:17'!
setUp

	super setUp.
	project := XpfProject addNewProject: (Dictionary with: 'title' -> 'bla').
	userStory := project addNewUserStory: (Dictionary with: 'title' -> 'blub').
	task := userStory addNewTask: (Dictionary with: 'title' -> 'brum').
	sut := XpfHistoryModel new.
	sut project: project.! !

!XpfHistoryTest methodsFor: 'tests' stamp: 'cs 4/8/2009 11:27'!
testAllSelected

	sut showProject: true.
	sut showUserStories: true.
	sut showTasks: true.
	self shouldnt: sut entries isEmpty.
	self should: sut entries size =
		(project history size +
		userStory history size +
		task history size).! !

!XpfHistoryTest methodsFor: 'tests' stamp: 'cs 4/8/2009 11:13'!
testNothingSelected

	sut showProject: false.
	sut showUserStories: false.
	sut showTasks: false.
	self should: sut entries isEmpty.! !

!XpfHistoryTest methodsFor: 'tests' stamp: 'cs 4/8/2009 11:27'!
testProjectSelected

	sut showProject: true.
	sut showUserStories: false.
	sut showTasks: false.
	self shouldnt: sut entries isEmpty.
	self should: sut entries size = project history size.! !

!XpfHistoryTest methodsFor: 'tests' stamp: 'cs 4/8/2009 11:27'!
testTasksSelected

	sut showProject: false.
	sut showUserStories: false.
	sut showTasks: true.
	self shouldnt: sut entries isEmpty.
	self should: sut entries size = task history size.! !

!XpfHistoryTest methodsFor: 'tests' stamp: 'cs 4/8/2009 11:28'!
testUserStoriesSelected

	sut showProject: false.
	sut showUserStories: true.
	sut showTasks: false.
	self shouldnt: sut entries isEmpty.
	self should: sut entries size = userStory history size.! !

XpfTestCase subclass: #XpfLoginTest
	instanceVariableNames: 'oldServer oldUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfLoginTest methodsFor: 'running' stamp: 'topa 4/3/2009 17:10'!
setUp

	super setUp.
	oldServer := XpfLoginModel defaultServer.
	oldUser := XpfLoginModel defaultUser.! !

!XpfLoginTest methodsFor: 'running' stamp: 'topa 4/3/2009 17:11'!
tearDown

	XpfLoginModel defaultServer: oldServer.
	XpfLoginModel defaultUser: oldUser.
	super tearDown.
! !

!XpfLoginTest methodsFor: 'tests' stamp: 'topa 4/3/2009 16:56'!
testLoginDialog

	| dlg |
	dlg := XpfLogin new.
	
	dlg serverEntry setText: 'example.com'.
	dlg loginEntry setText: 'random.guy@web.de'.
	dlg passwordEntry setText: 'secret'.
	
	dlg connectButton performAction.
	
	self
		should: dlg result = 'http://random.guy%40web.de:secret@example.com:8082/'! !

XpfTestCase subclass: #XpfProjectChooserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfProjectChooserTest methodsFor: 'tests' stamp: 'SR 3/10/2009 14:19'!
testChooserDialog

	| liste sut |
	liste := {XpfProject new title:'1'. XpfProject new title: '2'}.
	sut := XpfProjectChooser new.
	sut model projects: liste.
	sut model projectsModel selectionIndex: 1.
	sut okButton performAction.
	
	self
		should: sut result = (liste at: 1).! !

Object subclass: #XpfAdminToolModel
	instanceVariableNames: 'projects currentProjectIndex users currentUserIndex currentProjectCandidateIndex currentProjectDeveloperIndex reposistory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfAdminToolModel class methodsFor: 'as yet unclassified' stamp: 'mt 3/16/2009 11:29'!
newWithRepository: aRepository

	^ self new repository: aRepository! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'cs 3/9/2009 15:46'!
addDeveloperToProject

	self currentProject developers add: 
		(self currentProjectCandidates at: self currentProjectCandidateIndex).
			
	self currentProjectCandidateIndex: 0.
			
	self
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidateIndex;
		changed: #allProjectCandidateNames;
		changed: #hasCurrentProjectCandidates.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/16/2009 14:17'!
addProject
	| newProject |
	newProject := reposistory 
				addProject: (Dictionary newFrom: {  ('title' -> 'New Project')}).
	projects := nil.
	self
		changed: #allProjectTitles;
		changed: #hasProjects;
		currentProjectIndex: (self indexOfProject: newProject);
		changed: #hasCurrentProject! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/16/2009 14:17'!
addUser
	| newUser |
	newUser := reposistory 
				addUser: (Dictionary newFrom: { 
								('userName' -> 'New User').
								('login' -> 'new.user@email.de').
								('password' -> nil)}).
	users := nil.
	self
		changed: #allUserNames;
		changed: #hasUsers;
		currentUserIndex: (self indexOfUser: newUser);
		changed: #hasCurrentUser;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidates;
		changed: #hasCurrentProjectDevelopers! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 10:50'!
allProjectCandidateNames

	^ self currentProjectCandidates collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:48'!
allProjectDeveloperNames

	^ self currentProjectDevelopers collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/3/2009 17:04'!
allProjectTitles

	^ self projects collect: [:project | project title]! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 10:20'!
allUserNames

	^ self users collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'mt 3/6/2009 13:40'!
changePassword: aDialog

	| newPassword |
	newPassword := UITheme current 
		textEntryIn: aDialog
		text: ('Enter new password for ''{1}''' format: {self currentUserName})
		title: 'Change Password'
		entryText: ''.
				
	newPassword ifNil: [^ self].
	
	self currentUserPassword: newPassword! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:36'!
currentProject

	^ self projects at: self currentProjectIndex! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:48'!
currentProjectCandidateIndex

	^ currentProjectCandidateIndex! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/6/2009 16:38'!
currentProjectCandidateIndex: anObject

	currentProjectCandidateIndex := anObject.
	self
		changed: #currentProjectCandidateIndex;
		changed: #hasCurrentProjectCandidateIndex.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:49'!
currentProjectCandidates

	self hasCurrentProject ifFalse: [^ #()].
	
	^ self users reject: [:user | 
		self currentProject developers anySatisfy: [:dev | dev id = user id]]! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:48'!
currentProjectDeveloperIndex

	^ currentProjectDeveloperIndex! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:45'!
currentProjectDeveloperIndex: anObject

	currentProjectDeveloperIndex := anObject.
	self changed: #currentProjectDeveloperIndex.
	self changed: #hasCurrentProjectDeveloperIndex.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:49'!
currentProjectDevelopers

	self hasCurrentProject ifFalse: [^ #()].
	^ self currentProject developers ! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'topa 3/4/2009 00:23'!
currentProjectIndex

	^ currentProjectIndex! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 16:34'!
currentProjectIndex: anObject

	currentProjectIndex := anObject.
	self
		changed: #hasCurrentProject;
		changed: #currentProjectIndex;
		changed: #currentProjectTitle;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidates;
		changed: #hasCurrentProjectDevelopers.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 16:22'!
currentProjectTitle

	^ self hasCurrentProject
		ifTrue: [self allProjectTitles at: self currentProjectIndex]
		ifFalse: []! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:50'!
currentProjectTitle: aString

	self currentProject title: aString.
	self
		changed: #currentProjectTitle;
		changed: #allProjectTitles.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 15:37'!
currentUser

	^ self users at: self currentUserIndex! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 12:59'!
currentUserIndex
	^ currentUserIndex! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/6/2009 16:34'!
currentUserIndex: anObject

	currentUserIndex := anObject.
	self
		changed: #hasCurrentUser;
		changed: #currentUserIndex;
		changed: #currentUserName;
		changed: #currentUserLogin.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 16:04'!
currentUserLogin

	^ self hasCurrentUser
		ifTrue: [self currentUser login]
		ifFalse: []! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/31/2009 15:35'!
currentUserLogin: aString

	| oldLogin |
	oldLogin := (self users at: self currentUserIndex) login.
	(self users at: self currentUserIndex) login: aString.
	self repository login = oldLogin
		ifTrue: [self repository login: aString].
	self changed: #currentUserLogin.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 13:36'!
currentUserName

	^ self allUserNames at: self currentUserIndex ifAbsent: []! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/12/2009 12:34'!
currentUserName: aString

	self currentUser userName: aString.
	
	self flag: #temporary. projects := nil.
	
	self
		changed: #currentUserName;
		changed: #allUserNames;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/31/2009 15:58'!
currentUserPassword: aString

	(self users at: self currentUserIndex) password: aString.
	self repository login = self currentUserLogin
		ifTrue: [self repository password: aString].
	self changed: #currentUserPassword.! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'cs 3/9/2009 15:42'!
deleteDeveloper

	self currentProject developers remove: 
		(self currentProjectDevelopers at: self currentProjectDeveloperIndex).
			
	self currentProjectDeveloperIndex: (self currentProjectDeveloperIndex > self currentProject developers size 
			ifTrue: [self currentProject developers size] 
			ifFalse: [self currentProjectDeveloperIndex]).
			
	self
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidateIndex;
		changed: #allProjectCandidateNames;
		changed: #hasCurrentProjectCandidates.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 16:00'!
deleteProject

	self currentProject delete.
	projects := nil. "invalidate local projects"
	self
		changed: #allProjectTitles;
		changed: #hasProjects;
		currentProjectIndex: (self currentProjectIndex > self projects size 
			ifTrue: [self projects size] 
			ifFalse: [self currentProjectIndex]);
		changed: #hasCurrentProject.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 16:01'!
deleteUser

	self currentUser delete.
	users := nil. "invalidate local users"
	self
		changed: #allUserNames;
		changed: #hasUsers;
		currentUserIndex: (self currentUserIndex > self users size 
			ifTrue: [self users size] 
			ifFalse: [self currentUserIndex]);
		changed: #hasCurrentUser;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidates;
		changed: #hasCurrentProjectDevelopers.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/5/2009 13:35'!
hasCurrentProject

	^ self currentProjectIndex notNil and: 
		[(self currentProjectIndex > 0) & (self currentProjectIndex <= self projects size)]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/12/2009 10:50'!
hasCurrentProjectCandidateIndex

	^ self currentProjectCandidateIndex notNil and: 
		[(self currentProjectCandidateIndex > 0) & (self currentProjectCandidateIndex <= self currentProjectCandidates size)]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:38'!
hasCurrentProjectCandidates

	^ self currentProjectCandidates isEmpty not! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 16:01'!
hasCurrentProjectDeveloperIndex

	^ self hasCurrentProject and:
		[self currentProjectDeveloperIndex notNil and: 
		[(self currentProjectDeveloperIndex > 0) &
		(self currentProjectDeveloperIndex <= self currentProject developers size)]]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:38'!
hasCurrentProjectDevelopers

	^ self currentProjectDevelopers isEmpty not! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/5/2009 13:49'!
hasCurrentUser

	^ self currentUserIndex notNil and: 
		[(self currentUserIndex > 0) & (self currentUserIndex <= self users size)]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/5/2009 14:05'!
hasProjects

	^ self projects isEmpty not! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/5/2009 14:05'!
hasUsers

	^ self users isEmpty not! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 10:30'!
indexOfProject: aProject
	"returns the index of the specified project in the displayed list of projects"

	^ self projects indexOf: (self projects detect: [:each | each id = aProject id])! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 10:28'!
indexOfUser: aUser
	"returns the index of the specified user in the displayed list of users"

	^ self users indexOf: (self users detect: [:each | each id = aUser id])! !

!XpfAdminToolModel methodsFor: 'initialization' stamp: 'mt 3/6/2009 16:20'!
initialize

	super initialize.
	self
		currentProjectIndex: 0;
		currentUserIndex: 0;
		currentProjectCandidateIndex: 0;
		currentProjectDeveloperIndex: 0.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/16/2009 14:17'!
projects
	^ projects ifNil: 
			[projects := reposistory getAllProjects 
						sortBy: [:first :second | first title < second title]]! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/16/2009 14:17'!
repository

	^ reposistory! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/16/2009 14:17'!
repository: anObject

	reposistory := anObject.! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'SR 4/9/2009 08:44'!
updateUser: someEntries 
	self currentUser
		deferCommit: [someEntries
				do: [:entry | entry accept]]! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/16/2009 14:17'!
users
	^ users ifNil: 
			[users := reposistory getAllUsers 
						sortBy: [:first :second | first userName < second userName]]! !

Object subclass: #XpfChangePasswordModel
	instanceVariableNames: 'newPassword newPasswordRepeat user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfChangePasswordModel methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 16:07'!
accept

	(self newPassword = self newPasswordRepeat) ifTrue: [
		self user password: self newPassword.
		(self user respondsTo: #repository) ifFalse: [^ self].
		(self user login = self user repository login)
			ifTrue: [self repository password: self newPassword]].! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:50'!
newPassword

	^ newPassword! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:50'!
newPassword: anObject

	newPassword := anObject.! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:45'!
newPasswordRepeat

	^ newPasswordRepeat! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:45'!
newPasswordRepeat: anObject

	newPasswordRepeat := anObject.! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:46'!
user

	^ user! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:46'!
user: anObject

	user := anObject.! !

Object subclass: #XpfDeveloperChooserModel
	instanceVariableNames: 'developerList selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfDeveloperChooserModel methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 17:58'!
developer

	^ self selectionIndex = 0
		ifTrue: [nil]
		ifFalse: [self developerList at: self selectionIndex]! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:56'!
developerList
	^ developerList! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:11'!
developerList: anObject

	developerList := anObject.
	self changed: #list.
	self developerList ifNotEmpty: [self selectionIndex: 1].! !

!XpfDeveloperChooserModel methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 18:10'!
initialize

	super initialize.
	self selectionIndex: 0.! !

!XpfDeveloperChooserModel methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 17:57'!
list

	self developerList ifNil: [^ #()].
	^(self developerList collect: [:each | each userName]).! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:56'!
selectionIndex

	^ selectionIndex! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:56'!
selectionIndex: anObject

	selectionIndex := anObject.
	self changed: #selectionIndex.! !

Object subclass: #XpfHistoryEntryModel
	instanceVariableNames: 'entity entry entityType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfHistoryEntryModel methodsFor: 'as yet unclassified' stamp: 'cs 4/7/2009 14:38'!
asMorph

	^ XpfHistoryEntryMorph forEntry: self! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entity

	^ entity! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entity: anObject

	entity := anObject.! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 16:20'!
entityType

	^ entityType! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 16:20'!
entityType: anObject

	entityType := anObject.! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entry

	^ entry! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entry: anObject

	entry := anObject.! !

Object subclass: #XpfHistoryModel
	instanceVariableNames: 'project showProject showTasks showUserStories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:20'!
entries
	
	| result |
	result := OrderedCollection new.
	self showProject ifTrue: [result addAll: self projectEntries].
	self showUserStories ifTrue: [result addAll: self userStoryEntries].
	self showTasks ifTrue: [result addAll: self taskEntries].
	^ result! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:31'!
entriesAsMorphs
	
	^ self entries collect: [:entry | entry asMorph]! !

!XpfHistoryModel methodsFor: 'initialize-release' stamp: 'cs 4/8/2009 11:33'!
initialize

	super initialize.
	self showProject: true.
	self showUserStories: false.
	self showTasks: false.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:03'!
project

	^ project! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 18:34'!
project: anObject

	project := anObject.
	anObject addDependent: self.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 18:21'!
projectEntries
	
	^ project history collect: [:each |
		XpfHistoryEntryModel new
			entity: project;
			entry: each;
			entityType: #project]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 18:21'!
showProject

	^ showProject! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 18:35'!
showProject: anObject

	showProject := anObject.
	self changed: #showProject.
	self changed: #entriesAsMorphs.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:16'!
showTasks

	^ showTasks! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:16'!
showTasks: anObject

	showTasks := anObject.
	self changed: #showTasks.
	self changed: #entriesAsMorphs.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:18'!
showUserStories

	^ showUserStories! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:18'!
showUserStories: anObject

	showUserStories := anObject.
	self changed: #showUserStories.
	self changed: #entriesAsMorphs.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:37'!
taskEntries
	
	^ project tasks
		inject: OrderedCollection new
		into: [:old :eachTask | old addAll:
			(eachTask history collect: [:eachEntry |
				XpfHistoryEntryModel new
				entity: eachTask;
				entry: eachEntry;
				entityType: #task]). old]! !

!XpfHistoryModel methodsFor: 'updating' stamp: 'cs 4/7/2009 18:35'!
update: aSymbol

	super update: aSymbol.
	self changed: #entriesAsMorphs.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:37'!
userStoryEntries
	
	^ project userStories
		inject: OrderedCollection new
		into: [:old :eachUserStory | old addAll:
			(eachUserStory history collect: [:eachEntry |
				XpfHistoryEntryModel new
				entity: eachUserStory;
				entry: eachEntry;
				entityType: #userStory]). old]! !

Object subclass: #XpfIterationListModel
	instanceVariableNames: 'project selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:49'!
initialize

	super initialize.
	self selectionIndex: 0.! !

!XpfIterationListModel methodsFor: 'as yet unclassified' stamp: 'SR 4/10/2009 20:15'!
iteration

	^ (self selectionIndex = 0)
		ifTrue: [nil]
		ifFalse: [self project iterations at: (self reversedSelectionIndex)]! !

!XpfIterationListModel methodsFor: 'as yet unclassified' stamp: 'SR 4/10/2009 19:45'!
list

	self project  ifNil: [^ #()].
	^(self project iterations collect: [:each | each title]) reverse.! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:36'!
project

	^ project! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:48'!
project: anObject

	project := anObject.
	self project ifNotNil: [self project addDependent: self].
	self changed: #list.	! !

!XpfIterationListModel methodsFor: 'as yet unclassified' stamp: 'SR 4/10/2009 20:24'!
reversedSelectionIndex

	| baseIndex halfSize |
	baseIndex := self selectionIndex.
	halfSize := (self project iterations size / 2) ceiling.
	^ baseIndex < halfSize
		ifTrue: [baseIndex + ((halfSize - baseIndex) * 2)]
		ifFalse: [baseIndex - ((baseIndex - halfSize) * 2)].
	! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:47'!
selectionIndex

	^ selectionIndex! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:47'!
selectionIndex: anObject

	selectionIndex := anObject.
	self changed: #selectionIndex.! !

Object subclass: #XpfIterationTreeModel
	instanceVariableNames: 'iteration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfIterationTreeModel methodsFor: 'accessing' stamp: 'mt 4/1/2009 11:36'!
iteration

	^ iteration! !

!XpfIterationTreeModel methodsFor: 'accessing' stamp: 'SR 4/9/2009 09:22'!
iteration: anXpfIteration

	iteration := anXpfIteration.
	self iteration addDependent: self.! !

!XpfIterationTreeModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 12:49'!
rootItems

	| temp |
	temp :=  self iteration userStories collect: [:us | (XpfUserStoryItemWrapper with: nil model: us)].
	temp isEmpty
		ifTrue: [^ {ListItemWrapper with: ''}]
		ifFalse: [^ temp].! !

!XpfIterationTreeModel methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 14:43'!
update: aSymbol

	self changed: aSymbol.! !

Object subclass: #XpfLoginModel
	instanceVariableNames: 'server login password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

XpfLoginModel class
	instanceVariableNames: 'defaultUser defaultServer'!

XpfLoginModel class
	instanceVariableNames: 'defaultUser defaultServer'!

!XpfLoginModel class methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:35'!
defaultPort

	^ '8082'! !

!XpfLoginModel class methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:29'!
defaultServer

	^ defaultServer ifNil: ['localhost']! !

!XpfLoginModel class methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:29'!
defaultServer: anObject

	defaultServer := anObject.! !

!XpfLoginModel class methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:31'!
defaultUser
	
	^ defaultUser ifNil: ['']! !

!XpfLoginModel class methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:31'!
defaultUser: anObject

	defaultUser := anObject.! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:40'!
connectString

	self storeDefaults.
	^ RestProxyRepository
		url: 'http://', self server, ':', self class defaultPort, '/' 
		username: self login
		password: self password! !

!XpfLoginModel methodsFor: 'initialization' stamp: 'topa 4/3/2009 16:35'!
initialize

	super initialize.
	self
		server: self class defaultServer;
		login: self class defaultUser;
		password: ''.! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:53'!
login

	^ login! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:53'!
login: anObject

	login := anObject.! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:53'!
password

	^ password! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:54'!
password: anObject

	password := anObject.! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:33'!
server

	^ server! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:34'!
server: aString

	server := aString.! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:41'!
storeDefaults

		(self class)
			defaultServer: self server;
			defaultUser: self login.
! !

Object subclass: #XpfLoginProcessor
	instanceVariableNames: 'connectionString project user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:04'!
connectionString

	^ connectionString! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:04'!
connectionString: anObject

	connectionString := anObject! !

!XpfLoginProcessor methodsFor: 'private' stamp: 'SR 4/10/2009 19:02'!
getConnectionString

	self connectionString: (World openModal: XpfLogin new) result.
	self connectionString ifNil: [XpfClientOpenError signal].! !

!XpfLoginProcessor methodsFor: 'private' stamp: 'SR 4/10/2009 19:03'!
getProject

	| userResponse projectChooser |
	userResponse := RestSocket get: self connectionString , '/info'. 
	userResponse isOk ifFalse: [
		userResponse isUnauthorized
			ifTrue: [UITheme current 
					alertIn: World
					text: 'You are not authorized to access any resource on the server.'
					title: 'Connection failed'.
				XpfClientOpenError signal]
			ifFalse: [RestProxyRepository errorForCode: userResponse responseCode]].
	self user: ((XpfProxyRepository fromString: self connectionString) 
				getObject: userResponse content).
	
	projectChooser := XpfProjectChooser new
		passwordChangeDialog: XpfChangePasswordDialog new.
		
	projectChooser passwordChangeDialog model user: self user.
	projectChooser model projects: self user projects.
	
	self project: (World openModal: projectChooser) result.
	self project ifNil: [XpfClientOpenError signal].! !

!XpfLoginProcessor methodsFor: 'initialization' stamp: 'SR 4/10/2009 19:03'!
initialize

	super initialize.
	self getConnectionString.
	self tryToConnect.
	self getProject.! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:04'!
project

	^ project! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:04'!
project: anObject

	project := anObject! !

!XpfLoginProcessor methodsFor: 'private' stamp: 'SR 4/10/2009 19:03'!
tryToConnect

	| response |
	
	[response := RestSocket get: self connectionString] 
	on: NetworkError do: 
		[:e | UITheme current 
			alertIn: World
			text: e messageText
			title: 'Network Error'.
		XpfClientOpenError signal].
	
	response isNotFound ifTrue: 
		[UITheme current 
			alertIn: World
			text: 'You are not authorized to access any resource on the server.'
			title: 'Connection failed'.
		XpfClientOpenError signal].! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:04'!
user

	^ user! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:04'!
user: anObject

	user := anObject! !

Object subclass: #XpfProjectChooserModel
	instanceVariableNames: 'projects projectsModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfProjectChooserModel methodsFor: 'initialization' stamp: 'SR 3/10/2009 13:58'!
initialize
	
	super initialize.
	
	projects := OrderedCollection new.
	projectsModel := ListModel new.! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'SR 3/10/2009 14:04'!
project

	^ (self projectsModel selectionIndex = 0)
		ifTrue: [nil]
		ifFalse: [self projects at: self projectsModel selectionIndex]! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'SR 3/10/2009 11:45'!
projects
	^ projects! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'mfp 3/19/2009 11:19'!
projects: anObject

	projects := anObject.
	projectsModel list: (self projects collect: [:e | e title]).
	projectsModel list ifNotEmpty: [projectsModel selectionIndex: 1]. 
	self changed.! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'SR 3/10/2009 13:58'!
projectsModel
	^ projectsModel! !

Object subclass: #XpfProxyObjectMock
	instanceVariableNames: 'entity relatives'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

XpfProxyObjectMock class
	instanceVariableNames: 'nextId'!

XpfProxyObjectMock class
	instanceVariableNames: 'nextId'!

!XpfProxyObjectMock class methodsFor: 'instance creation' stamp: 'mt 3/6/2009 16:10'!
newProjectMock

	^ self new entity: (XpfProject new title: 'Born to be deleted'; id: self nextId)! !

!XpfProxyObjectMock class methodsFor: 'instance creation' stamp: 'mt 3/6/2009 16:10'!
newUserMock

	^ self new entity: (XpfUser new userName: 'Mr. Lemming'; id: self nextId)! !

!XpfProxyObjectMock class methodsFor: 'accessing' stamp: 'mt 3/6/2009 16:11'!
nextId

	nextId ifNil: [nextId := 0].
	nextId := nextId + 1.
	^ nextId! !

!XpfProxyObjectMock class methodsFor: 'accessing' stamp: 'mt 3/6/2009 16:10'!
nextId: anObject
	nextId := anObject! !

!XpfProxyObjectMock methodsFor: 'as yet unclassified' stamp: 'SR 4/6/2009 21:36'!
deferCommit: aBlock
	^ aBlock value! !

!XpfProxyObjectMock methodsFor: 'deleting' stamp: 'mt 3/5/2009 12:04'!
delete

	relatives remove: self! !

!XpfProxyObjectMock methodsFor: 'error handling' stamp: 'mt 3/5/2009 12:16'!
doesNotUnderstand: aMessage

	| result |
	result := entity perform: aMessage selector withArguments: aMessage arguments.
	^ result = entity ifTrue: [self] ifFalse: [result]! !

!XpfProxyObjectMock methodsFor: 'accessing' stamp: 'mt 3/5/2009 12:05'!
entity
	^ entity! !

!XpfProxyObjectMock methodsFor: 'accessing' stamp: 'mt 3/5/2009 12:05'!
entity: anObject
	entity := anObject! !

!XpfProxyObjectMock methodsFor: 'accessing' stamp: 'mt 3/5/2009 12:05'!
relatives
	^ relatives! !

!XpfProxyObjectMock methodsFor: 'accessing' stamp: 'mt 3/5/2009 12:05'!
relatives: anObject
	relatives := anObject! !

Object subclass: #XpfProxyRepositoryMock
	instanceVariableNames: 'projects users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfProxyRepositoryMock methodsFor: 'add-remove' stamp: 'mt 3/5/2009 12:14'!
addProject: aDictionary

	^ projects add: (XpfProxyObjectMock new
		entity: (XpfProject newFrom: aDictionary);
		relatives: projects)! !

!XpfProxyRepositoryMock methodsFor: 'add-remove' stamp: 'mt 3/5/2009 10:55'!
addUser: aDictionary

	^ users add: (XpfUser newFrom: aDictionary)! !

!XpfProxyRepositoryMock methodsFor: 'accessing' stamp: 'mt 3/5/2009 09:55'!
getAllProjects

	^ projects! !

!XpfProxyRepositoryMock methodsFor: 'accessing' stamp: 'mt 3/5/2009 10:54'!
getAllUsers

	^ users! !

!XpfProxyRepositoryMock methodsFor: 'initialization' stamp: 'mt 3/6/2009 14:32'!
initialize

	super initialize.
	projects := {XpfProxyObjectMock newProjectMock. XpfProxyObjectMock newProjectMock title: self projectTitle} asOrderedCollection.
	users := {XpfProxyObjectMock newUserMock. XpfProxyObjectMock newUserMock login: self userLogin; userName: self userName; password: self userPassword} asOrderedCollection.
	
	projects do: [:project | project relatives: projects].
	users do: [:user | 
		user relatives: users. 
		projects second developers add: user].
! !

!XpfProxyRepositoryMock methodsFor: 'accessing' stamp: 'mt 3/31/2009 15:47'!
login
	
	^ ''! !

!XpfProxyRepositoryMock methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:39'!
projectTitle

	^ 'test project'! !

!XpfProxyRepositoryMock methodsFor: 'accessing' stamp: 'mt 3/4/2009 11:17'!
userLogin

	^ 'random.guy'! !

!XpfProxyRepositoryMock methodsFor: 'accessing' stamp: 'mt 3/4/2009 12:17'!
userName

	^ 'Random Guy'! !

!XpfProxyRepositoryMock methodsFor: 'accessing' stamp: 'mt 3/6/2009 13:26'!
userPassword

	^ 'topsecret'! !

BorderedMorph subclass: #XpfEntityMorph
	instanceVariableNames: 'model inEditMode inZoomMode buttonContent zoomContent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfEntityMorph class methodsFor: 'as yet unclassified' stamp: 'mt 3/13/2009 13:49'!
defaultColor

	^ self subclassResponsibility! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mig 3/31/2009 17:47'!
acceptSubmorphs

	self model deferCommit: [
		self submorphs ifNotNil: [
			self submorphs do: [:contentMorph |  contentMorph accept]]].! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/18/2009 15:28'!
buttonContent

	buttonContent ifNil: [self buttonContent:
		(XpfEditButtons new
			addDependent: self;
			yourself)].
	^ buttonContent! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/18/2009 15:26'!
buttonContent: anObject

	buttonContent := anObject! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'mfp 3/18/2009 17:13'!
click: evt! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'mfp 3/19/2009 16:39'!
doubleClick: evt

	self inEditMode 
		ifTrue: [self update: #cancelled]
		ifFalse: [self toggleEditMode].

	! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'SR 3/19/2009 19:39'!
doubleClickTimeout: evt

! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'mfp 3/18/2009 17:08'!
handlesMouseDown: evt

	^ true! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/19/2009 17:56'!
inEditMode

	^ inEditMode! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/19/2009 17:57'!
inEditMode: anObject

	inEditMode := anObject.! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'SR 3/19/2009 19:19'!
inZoomMode
	^ inZoomMode! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'SR 3/19/2009 19:19'!
inZoomMode: anObject
	inZoomMode := anObject! !

!XpfEntityMorph methodsFor: 'initialization' stamp: 'topa 3/23/2009 11:13'!
initialize

	super initialize.
	self
		inEditMode: false;
		inZoomMode: false;
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		borderWidth: 1;
		layoutInset: 1;
		color: self class defaultColor;
		enableDragNDrop;
		useTitleContent.! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mt 3/13/2009 13:54'!
model

	^ model! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/17/2009 16:45'!
model: anXpfEntity

	self model ifNotNil: [self model removeDependent: self].
	model := anXpfEntity.
	self model addDependent: self.
	self updateContentModel.
	! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'SR 3/19/2009 19:38'!
mouseDown: evt
	"Do nothing upon mouse-down except inform the hand to watch for a 
	double-click; wait until an ensuing click:, doubleClick:, or drag: 
	message gets dispatched"
	
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {#click:. #doubleClick:. #doubleClickTimeout:. #startDrag:}
		threshold: 5.! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'SR 3/19/2009 19:39'!
startDrag: evt

	evt redButtonPressed ifTrue: [
		evt hand grabMorph: self].! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/19/2009 16:15'!
toggleEditMode
	
	self submorphs do: [:contentMorph | 
		contentMorph isEntityMorphContent ifTrue: 
			[contentMorph toggleEditMode]].
	
	self inEditMode: self inEditMode not.
	
	self inEditMode 
		ifTrue: [self addMorphBack: self buttonContent]
		ifFalse: [self removeMorph: self buttonContent]! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'SR 3/19/2009 19:22'!
toggleZoomMode
	
	self inZoomMode
		ifTrue: [self changed: #zoomOut]
		ifFalse: [self changed: #zoomIn].! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'mfp 3/20/2009 11:57'!
update: aSymbol
	
	aSymbol = #accepted ifTrue: [self acceptSubmorphs].
		
	aSymbol = #cancelled
		ifTrue: [self submorphs do: [:contentMorph | contentMorph cancel]].		

	(aSymbol = #accepted) | (aSymbol = #cancelled)
		ifTrue: [self toggleEditMode].
		
	aSymbol = #zoomIn
		ifTrue: [self useDetailContent. self inZoomMode: true.].
	
	aSymbol = #zoomOut
		ifTrue: [self useTitleContent. self inZoomMode: false.].
	
	super update: aSymbol.

	! !

!XpfEntityMorph methodsFor: 'private' stamp: 'mfp 3/17/2009 16:08'!
updateContentModel

	(self model isNil | self submorphs isNil) ifTrue: [^ self].
	self submorphs do: [:contentMorph | contentMorph model: self model].! !

!XpfEntityMorph methodsFor: 'content handling' stamp: 'mfp 3/18/2009 18:36'!
useDetailContent

	self subclassResponsibility.! !

!XpfEntityMorph methodsFor: 'content handling' stamp: 'mfp 3/19/2009 16:38'!
useTitleContent

	self subclassResponsibility.! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/18/2009 18:14'!
zoomContent

	zoomContent ifNil: [self zoomContent:
		(XpfZoomButtons new
			addDependent: self;
			yourself)].
	^ zoomContent! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/18/2009 18:14'!
zoomContent: anObject

	zoomContent := anObject.! !

XpfEntityMorph subclass: #XpfTaskMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTaskMorph class methodsFor: 'defaults' stamp: 'mt 3/13/2009 11:08'!
defaultColor

	^ Color white! !

!XpfTaskMorph class methodsFor: 'initialize-release' stamp: 'mfp 3/20/2009 11:23'!
forTask: anXpfTask

	^ self basicNew
		model: anXpfTask;
		initialize;
		update: anXpfTask! !

!XpfTaskMorph methodsFor: 'as yet unclassified' stamp: 'mfp 3/20/2009 11:11'!
click: evt

	evt yellowButtonPressed ifTrue: [
		self openContextPopupMenu.
		evt wasHandled: true].! !

!XpfTaskMorph methodsFor: 'testing' stamp: 'mt 3/13/2009 14:50'!
isTaskMorph

	^ true! !

!XpfTaskMorph methodsFor: 'as yet unclassified' stamp: 'mfp 3/20/2009 11:21'!
openContextPopupMenu

	| menu |
	menu := MenuMorph new.
	menu addTitle: 'Set Status'.
	menu add: 'Done' target: self model selector: #isDone: argument: true.
	menu addLine.
	menu add: 'Open' target: self model selector: #isDone: argument: false.
	menu popUpInWorld.
! !

!XpfTaskMorph methodsFor: 'as yet unclassified' stamp: 'mfp 3/20/2009 11:56'!
update: aSymbol

	super update: aSymbol.

	self model isDone
		ifTrue: [self color: Color green muchLighter]
		ifFalse: [self color: Color red muchLighter]! !

!XpfTaskMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/10/2009 15:24'!
useDetailContent

	self
		acceptSubmorphs;
		removeAllMorphs;
		addMorph: (XpfTaskTitleExplanationContent forModel: self model);
		addMorphBack: self zoomContent;
		addMorphBack: (XpfEstimationContent forModel: self model);
		addMorphBack: (XpfResponsibleDeveloperContent forModel: self model).! !

!XpfTaskMorph methodsFor: 'as yet unclassified' stamp: 'mig 3/31/2009 17:23'!
useTitleContent

	self
		removeAllMorphs;
		addMorph: (XpfTaskTitleContent forModel: self model);
		addMorphBack: self zoomContent.
! !

!XpfTaskMorph methodsFor: 'as yet unclassified' stamp: 'mfp 3/19/2009 14:42'!
wantsToBeDroppedInto: aMorph

	^ aMorph acceptsTasks! !

XpfEntityMorph subclass: #XpfUserStoryMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'mfp 3/17/2009 15:34'!
defaultColor
	
	^	Color white.! !

!XpfUserStoryMorph class methodsFor: 'initialize-release' stamp: 'mfp 3/17/2009 16:04'!
forUserStory: anXpfUserStory

	^ self basicNew
		model: anXpfUserStory;
		initialize! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'mfp 3/18/2009 17:12'!
click: evt

	evt yellowButtonPressed ifTrue: [
		self openContextPopupMenu.
		evt wasHandled: true].! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'mig 4/3/2009 13:51'!
initialize
	
	super initialize.
	self updateColor.! !

!XpfUserStoryMorph methodsFor: 'testing' stamp: 'topa 3/4/2009 00:21'!
isUserStoryMorph

	^ true! !

!XpfUserStoryMorph methodsFor: 'private' stamp: 'mig 4/3/2009 13:44'!
openContextPopupMenu

	| menu |
	menu := MenuMorph new.
	menu addTitle: 'Set Color'.
	#(red orange yellow green cyan blue magenta gray white) do: [:currentColor |
		menu
			add: currentColor asString capitalized
			target: self model
			selector: #color:
			argument: currentColor asString].
	menu popUpInWorld.
! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'SR 4/9/2009 09:22'!
update: aSymbol 
	
	aSymbol = #color ifTrue: [ self updateColor ].
	(aSymbol = #positionY
			or: [aSymbol = #positionX])
		ifTrue: [self updatePosition].
	super update: aSymbol.! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'mig 4/3/2009 13:45'!
updateColor

	self color: (Color colorFrom: self model color asSymbol) muchLighter.! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'SR 4/7/2009 14:24'!
updatePosition
	self layoutChanged! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'topa 3/23/2009 11:19'!
useDetailContent

	self 
		acceptSubmorphs;
		removeAllMorphs;
		addMorph: (XpfUserStoryTitleExplanationContent forModel: self model);
		addMorphBack: self zoomContent;
		addMorphBack: (XpfEstimationContent forModel: self model);
		addMorphBack: (XpfTasksContent forModel: self model).! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'mig 3/31/2009 17:23'!
useTitleContent
	
	self
		removeAllMorphs;
		addMorph: (XpfUserStoryTitleContent forModel: self model);
		addMorphBack: self zoomContent.
! !

!XpfUserStoryMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 3/18/2009 16:58'!
wantsToBeDroppedInto: aMorph

	^ aMorph acceptsUserStories! !

BorderedMorph subclass: #XpfListEntryMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:21'!
defaultColor

	self subclassResponsibility! !

!XpfListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:34'!
for: aXpfObject

	^self new model: aXpfObject.! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:22'!
createUserInterface

	self subclassResponsibility! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:28'!
initialize

	super initialize.
	self
		changeTableLayout;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		color: self class defaultColor.! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:07'!
model

	^model! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:29'!
model: anXpfUserStory

	self model ifNotNil: [self model removeDependent: self].
	model := anXpfUserStory.
	self model ifNotNil: [
		self removeAllMorphs.
		self createUserInterface.
		self model addDependent: self].! !

XpfListEntryMorph subclass: #XpfTaskListEntryMorph
	instanceVariableNames: 'titleMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:35'!
defaultColor

	^ Color red! !

!XpfTaskListEntryMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 23:06'!
createUserInterface

	self
		addMorph: (XpfTaskTitleContent forModel: self model);
		addMorphBack: (XpfEstimationContent forModel: self model);
		addMorphBack: ((XpfResponsibleDeveloperContent forModel: self model) toggleEditMode);
		addMorphBack: (XpfWorkTimerContent forModel: self model).! !

XpfListEntryMorph subclass: #XpfUserStoryListEntryMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfUserStoryListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:21'!
defaultColor

	^ Color yellow! !

!XpfUserStoryListEntryMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:20'!
createUserInterface

	self
		addMorph: (XpfUserStoryTitleContent forModel: self model);
		addMorphBack: (XpfEstimationContent forModel: self model).! !

BorderedMorph subclass: #XpfUserStoryAddMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryAddMorph commentStamp: 'topa 3/9/2009 15:16' prior: 0!
I am a Morph that should behave somehow like a Button, yet are embeddable into
a PasteUpMorph.!

!XpfUserStoryAddMorph class methodsFor: 'defaults' stamp: 'topa 3/9/2009 15:13'!
defaultBorderColor

	^ Color darkGray! !

!XpfUserStoryAddMorph class methodsFor: 'defaults' stamp: 'topa 3/11/2009 14:22'!
defaultColor

	^ Color tan! !

!XpfUserStoryAddMorph class methodsFor: 'defaults' stamp: 'topa 3/9/2009 15:13'!
defaultExtent

	^ 100@60 ! !

!XpfUserStoryAddMorph class methodsFor: 'defaults' stamp: 'topa 3/11/2009 14:27'!
defaultShadowColor

	^ Color darkGray! !

!XpfUserStoryAddMorph class methodsFor: 'defaults' stamp: 'topa 3/9/2009 17:01'!
emptyUserStory

	^ Dictionary newFrom:	{ 
			'id' -> nil.
			'title' -> nil.
			'priority' -> nil.
			'timeEstimated' -> nil.
			'timeActual' -> nil.
			'explanation' -> nil}! !

!XpfUserStoryAddMorph class methodsFor: 'initialize-release' stamp: 'cs 3/11/2009 17:57'!
forProjects: anXpfProject

	^ self new model: anXpfProject! !

!XpfUserStoryAddMorph methodsFor: 'event handling' stamp: 'topa 3/11/2009 14:00'!
handlesMouseDown: evt

	self enabled ifTrue:
		[evt hand waitForClicksOrDrag: self event: evt].
	^ true! !

!XpfUserStoryAddMorph methodsFor: 'initialization' stamp: 'topa 3/11/2009 14:26'!
initialize

	super initialize.
	self
		extent: self class defaultExtent;
		color: self class defaultColor;
		borderColor: self class defaultBorderColor;
		borderWidth: 1;
		useRoundedCorners;
		addDropShadow; shadowOffset: 5@5; shadowColor: self class defaultShadowColor.! !

!XpfUserStoryAddMorph methodsFor: 'accessing' stamp: 'topa 3/11/2009 15:20'!
model

	^ model! !

!XpfUserStoryAddMorph methodsFor: 'accessing' stamp: 'topa 3/11/2009 15:20'!
model: anObject

	model := anObject.! !

!XpfUserStoryAddMorph methodsFor: 'event handling' stamp: 'cs 3/18/2009 15:28'!
mouseDown: evt
	
	^ self performAction openInHand! !

!XpfUserStoryAddMorph methodsFor: 'event handling' stamp: 'cs 3/18/2009 15:28'!
performAction
	"for Button behavior"

	^ (XpfUserStoryMorph forUserStory: 
		(self model addNewUserStory: self class emptyUserStory))
		changed: #newModel! !

!ListItemWrapper methodsFor: '*Xpf-Client' stamp: 'SR 4/7/2009 16:04'!
hasXpfModel

	^ false! !

ListItemWrapper subclass: #XpfEntityItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfEntityItemWrapper class methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 13:14'!
with: anObject model: aModel

	| result |
	result := super with: anObject model: aModel.
	aModel addDependent: result.
	^ result! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mfp 3/26/2009 13:02'!
asString

	^ (model title ifNil: ['(no title)']) truncateWithElipsisTo: 25! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mfp 3/26/2009 13:03'!
balloonText

	^ (model title ifNil: ['(no title)']) withNoLineLongerThan: 25! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:50'!
contents

	^ {self createTimeEstimatedItem.
		self createTimeActualItem}! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 17:13'!
createTimeActualItem

	^ (XpfValueBarWrapper with: nil model: self model)
		getValueSelector: #timeActual;
		preferredColor: ((self model timeEstimated isNil | self model timeActual isNil)
			ifTrue: [Color black]
			ifFalse: [(self model timeEstimated >= self model timeActual
				ifTrue: [Color green muchDarker]
				ifFalse: [Color red])]);
		prefix: 'Actual Time:'! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 17:09'!
createTimeEstimatedItem

	^ (XpfValueBarWrapper with: nil model: self model)
		getValueSelector: #timeEstimated;
		preferredColor: (self model timeEstimated isNil
			ifNil: [Color black]
			ifNotNil: [Color blue]);
		prefix: 'Estimated Time:'! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:33'!
hasXpfModel

	^ true! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 14:29'!
update: aSymbol

	super update: aSymbol.
	self changed: #rootItems.! !

XpfEntityItemWrapper subclass: #XpfUserStoryItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfUserStoryItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:53'!
contents

	^ super contents asOrderedCollection
		add: self createTasksItem;
		yourself! !

!XpfUserStoryItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:48'!
createTasksItem

	^ XpfTaskListItemWrapper with: nil model: self model tasks! !

ListItemWrapper subclass: #XpfTaskListItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfTaskListItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 17:02'!
asString

	^ 'Tasks'! !

!XpfTaskListItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:48'!
contents

	^ self model collect: [:task |
		XpfEntityItemWrapper with: nil model: task]! !

!XpfTaskListItemWrapper methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:04'!
hasXpfModel

	^ true! !

ListItemWrapper subclass: #XpfValueBarWrapper
	instanceVariableNames: 'getValueSelector preferredColor prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfValueBarWrapper class methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:05'!
max

	^ 25! !

!XpfValueBarWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 17:11'!
asString

	| value |
	
	value := self model perform: self getValueSelector.
	
	value ifNil: [^ '(not set)'].
	^ (String new: ((10 * value) / self class max) ceiling) collect: [:e | $+]! !

!XpfValueBarWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:33'!
balloonText

	^ '{1} {2}' format: {self prefix. self model perform: self getValueSelector}! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:03'!
getValueSelector
	^ getValueSelector! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:03'!
getValueSelector: anObject
	getValueSelector := anObject! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:21'!
preferredColor

	^ preferredColor! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:22'!
preferredColor: anObject

	preferredColor := anObject.! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:31'!
prefix
	^ prefix! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:31'!
prefix: anObject
	prefix := anObject! !

Error subclass: #XpfClientOpenError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

PluggableDialogWindow subclass: #XpfDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

XpfDialog subclass: #XpfAdminTool
	instanceVariableNames: 'projectList userList projectTitleEntry userNameEntry userLoginEntry saveProjectButton saveUserButton projectAddButton userAddButton projectDeleteButton userDeleteButton userPasswordButton projectDeveloperList projectUserDropList projectAddDeveloperButton projectDeleteDeveloperButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-AdminTool'!

!XpfAdminTool class methodsFor: 'user interface' stamp: 'topa 4/6/2009 16:20'!
open

	| instance connectionString factory response |
	self flag: #NeedsRefactoring.
	instance := self new.
	connectionString := (instance openModal: XpfLogin new) result.
	connectionString ifNil: [^ self].
	[response := RestSocket get: connectionString] on: ConnectionTimedOut
		do: 
			[:e | 
			UITheme current 
				alertIn: instance
				text: e messageText
				title: 'Connection timed out'.
			^ self].
	response responseCode = 401 
		ifTrue: 
			[UITheme current 
				alertIn: instance
				text: 'You are not authorized to access any resource on the server.'
				title: 'Connection failed'.
			^ self].
	factory := XpfProxyRepository fromString: connectionString.
	^ (instance initializeWith: factory) openInWorld! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 10:21'!
createProjectAddButtonFor: myModel 

	self projectAddButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #addProject
		arguments: nil
		getEnabled: nil
		label: 'Add Project'
		help: 'Add new project').
	^ self projectAddButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 16:37'!
createProjectAddDeveloperButtonFor: myModel 

	self projectAddDeveloperButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #addDeveloperToProject
		arguments: nil
		getEnabled: #hasCurrentProjectCandidateIndex
		label: 'Add'
		help: 'Add the candidate as developer to this project.').
	^ self projectAddDeveloperButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 13:15'!
createProjectDeleteButtonFor: myModel 

	self projectDeleteButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #deleteProject
		arguments: nil
		getEnabled: #hasProjects
		label: 'Delete Project'
		help: 'Delete project').
	^ self projectDeleteButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'cs 3/9/2009 15:29'!
createProjectDeleteDeveloperButtonFor: myModel 

	self projectDeleteDeveloperButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #deleteDeveloper
		arguments: nil
		getEnabled: #hasCurrentProjectDeveloperIndex
		label: 'Remove'
		help: 'Remove the selected developer from the current project. The user remains in the database.').
	^ self projectDeleteDeveloperButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 15:48'!
createProjectDeveloperListFor: aModel

	self projectDeveloperList: (UITheme current
		newListIn: self
		for: aModel
		list: #allProjectDeveloperNames
		selected: #currentProjectDeveloperIndex
		changeSelected: #currentProjectDeveloperIndex:
		getEnabled: nil
		help: 'Shows all developers of this project.').
	^ self projectDeveloperList minHeight: 150! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:21'!
createProjectListFor: aModel

	self projectList: (UITheme current
		newListIn: self
		for: aModel
		list: #allProjectTitles
		selected: #currentProjectIndex
		changeSelected: #currentProjectIndex:
		getEnabled: nil
		help: 'Shows all projects.').
	^ self projectList minHeight: 150! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:20'!
createProjectTitleEntryFor: myModel

	self projectTitleEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #currentProjectTitle
		set: #currentProjectTitle:
		class: String
		getEnabled: #hasCurrentProject
		help: 'Enter a short descriptive title for this project.') maxLength: 100).
	^ self projectTitleEntry minWidth: 200! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 15:49'!
createProjectUserDropListFor: aModel

	self projectUserDropList: (UITheme current
		newDropListIn: self
		for: aModel
		list: #allProjectCandidateNames
		getSelected: #currentProjectCandidateIndex
		setSelected: #currentProjectCandidateIndex:
		getEnabled: #hasCurrentProjectCandidates
		useIndex: true
		help: 'All available users for this project').
	^ self projectUserDropList! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'cs 3/9/2009 15:39'!
createProjectsTabFor: myModel 

	| col row |
	col := self createCol: { 
		self createRow: {self createLabel: 'Title:'. self createProjectTitleEntryFor: myModel}.
		self createRow: {self createHFiller. self createSaveProjectButton}.
		self createHSeparator.
		self createRow: {
			self createLabel: 'Developers:'.
			self createHFiller.
			self createProjectDeleteDeveloperButtonFor: myModel}.
		self createProjectDeveloperListFor: myModel.
		self createRow: {
			self createLabel: 'Candidate:'. 
			self createProjectUserDropListFor: myModel. 
			self createProjectAddDeveloperButtonFor: myModel}}.
		
	row := self createRow: {
		self createCol: {
			self createProjectListFor: myModel. 
			self createRow: {
				self createProjectAddButtonFor: myModel. 
				self createProjectDeleteButtonFor: myModel. 
				self createHFiller}}.
		self createVSeparator.
		col}.
	row vResizing: #spaceFill.
	^ row! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mig 3/13/2009 16:02'!
createQuitButton

	^ UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Quit'
		help: 'Close the admin tool'! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 13:30'!
createSaveProjectButton

	self saveProjectButton: (UITheme current 
		newButtonIn: self
		for: self projectTitleEntry
		getState: nil
		action: #accept
		arguments: nil
		getEnabled: #enabled
		label: 'Save'
		help: 'Save changed project title').
	^ self saveProjectButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:35'!
createSaveUserButtonFor: myModel

	self saveUserButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #updateUser:
		arguments: {{self userNameEntry. self userLoginEntry}}
		getEnabled: #hasCurrentUser
		label: 'Save'
		help: 'Save changed user data').
	^ self saveUserButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 11:00'!
createUserAddButtonFor: myModel 

	self userAddButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #addUser
		arguments: nil
		getEnabled: nil
		label: 'Add User'
		help: 'Add new user').
	^ self userAddButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:05'!
createUserDeleteButtonFor: myModel 

	self userDeleteButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #deleteUser
		arguments: nil
		getEnabled: #hasUsers
		label: 'Delete User'
		help: 'Delete User').
	^ self userDeleteButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:23'!
createUserListFor: aModel

	self userList: (UITheme current
		newListIn: self
		for: aModel
		list: #allUserNames
		selected: #currentUserIndex
		changeSelected: #currentUserIndex:
		getEnabled: nil
		help: 'Shows all users.').
	^ self userList minHeight: 150! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:03'!
createUserLoginEntryFor: myModel

	self userLoginEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #currentUserLogin
		set: #currentUserLogin:
		class: String
		getEnabled: #hasCurrentUser
		help: 'Enter a valid email address') maxLength: 100).
	^ self userLoginEntry! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:23'!
createUserNameEntryFor: myModel

	self userNameEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #currentUserName
		set: #currentUserName:
		class: String
		getEnabled: #hasCurrentUser
		help: 'Enter the name of the user.') maxLength: 100).
	^ self userNameEntry minWidth: 200! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 13:35'!
createUserPasswordButtonFor: myModel 

	self userPasswordButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #changePassword:
		arguments: {self}
		getEnabled: #hasCurrentUser
		label: 'Change Password...'
		help: 'Change the current password').
	^ self userPasswordButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 13:36'!
createUsersTabFor: myModel

	| col row |
	col := self createCol: { 
		self createRow: {
			self createLabel: 'Name:'. 
			self createUserNameEntryFor: myModel}.
		self createRow: {
			self createLabel: 'Login/E-Mail:'. 
			self createUserLoginEntryFor: myModel}.
		self createRow: {
			self createUserPasswordButtonFor: myModel.
			self createHFiller. 
			self createSaveUserButtonFor: myModel}}.
		
	row := self createRow: {
		self createCol: {
			self createUserListFor: myModel. 
			self createRow: {
				self createUserAddButtonFor: myModel. 
				self createUserDeleteButtonFor: myModel. 
				self createHFiller}}.
		self createVSeparator.
		col}.
	
	row vResizing: #spaceFill.
	^ row! !

!XpfAdminTool methodsFor: 'initialization' stamp: 'mt 3/6/2009 14:26'!
initializeUserInterface: myModel

	^ UITheme current
		newTabGroupIn: self for: {
			'Projects' -> (self createProjectsTabFor: myModel). 
			'Users' -> (self createUsersTabFor: myModel)}! !

!XpfAdminTool methodsFor: 'initialization' stamp: 'mt 3/16/2009 11:25'!
initializeWith: aRepository 
	| myModel |
	myModel := XpfAdminToolModel newWithRepository: aRepository.
	self
		buttons: {  (self createQuitButton)};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Project Management'! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 09:46'!
projectAddButton
	^ projectAddButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 09:46'!
projectAddButton: anObject
	projectAddButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectAddDeveloperButton
	^ projectAddDeveloperButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectAddDeveloperButton: anObject
	projectAddDeveloperButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:36'!
projectDeleteButton
	^ projectDeleteButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:36'!
projectDeleteButton: anObject
	projectDeleteButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:25'!
projectDeleteDeveloperButton
	
	^ projectDeleteDeveloperButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:24'!
projectDeleteDeveloperButton: anObject

	projectDeleteDeveloperButton := anObject.! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectDeveloperList
	^ projectDeveloperList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectDeveloperList: anObject
	projectDeveloperList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:00'!
projectList

	^ projectList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:00'!
projectList: anObject

	projectList := anObject.! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:05'!
projectTitleEntry
	^ projectTitleEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:05'!
projectTitleEntry: anObject
	projectTitleEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectUserDropList
	^ projectUserDropList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectUserDropList: anObject
	projectUserDropList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveProjectButton
	^ saveProjectButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveProjectButton: anObject
	saveProjectButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveUserButton
	^ saveUserButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveUserButton: anObject
	saveUserButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:02'!
userAddButton
	^ userAddButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:02'!
userAddButton: anObject
	userAddButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 13:48'!
userDeleteButton
	^ userDeleteButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 13:48'!
userDeleteButton: anObject
	userDeleteButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 12:57'!
userList
	^ userList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 12:57'!
userList: anObject
	userList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 14:44'!
userLoginEntry
	^ userLoginEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 14:44'!
userLoginEntry: anObject
	userLoginEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:30'!
userNameEntry
	^ userNameEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:30'!
userNameEntry: anObject
	userNameEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 13:32'!
userPasswordButton
	^ userPasswordButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 13:32'!
userPasswordButton: anObject
	userPasswordButton := anObject! !

XpfDialog subclass: #XpfChangePasswordDialog
	instanceVariableNames: 'okButton cancelButton oldPasswordEntry newPasswordEntry newPasswordRepeatEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/31/2009 12:03'!
cancelButton

	cancelButton ifNil: [
		cancelButton := UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Cancel'
		help: 'Abandons your new password and closes the window'].
	^ cancelButton! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:56'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 16:12'!
createNewPasswordEntryFor: anXpfChangePasswordModel

	self newPasswordEntry: ((UITheme current 
		newTextEntryIn: self
		for: anXpfChangePasswordModel 
		get: #newPassword
		set: #newPassword:
		class: String
		getEnabled: nil
		help: 'Enter new password')
		minWidth: 50;
		maxLength: 100).
	self newPasswordEntry textMorph font: (StrikeFont passwordFontSize: 12).
	^ self newPasswordEntry! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 16:12'!
createNewPasswordRepeatEntryFor: anXpfChangePasswordModel

	self newPasswordRepeatEntry: ((UITheme current 
		newTextEntryIn: self
		for: anXpfChangePasswordModel 
		get: #newPasswordRepeat
		set: #newPasswordRepeat:
		class: String
		getEnabled: nil
		help: 'Repeat new password')
		minWidth: 50;
		maxLength: 100).
	self newPasswordRepeatEntry textMorph font: (StrikeFont passwordFontSize: 12).
	^ self newPasswordRepeatEntry! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 14:57'!
initialize

	| myModel |
	super initialize.
	myModel := XpfChangePasswordModel new.
	self
		buttons: {self okButton. self cancelButton};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Change Password'.! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 16:12'!
initializeUserInterface: anXpfChangePasswordModel

	^ self createCol: {
		self createRow: {
			self createLabel: 'New:'.
			self createNewPasswordEntryFor: anXpfChangePasswordModel}.
		self createRow: {
			self createLabel: 'Confirm:'.
			self createNewPasswordRepeatEntryFor: anXpfChangePasswordModel}}! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:56'!
newPasswordEntry

	^ newPasswordEntry! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:56'!
newPasswordEntry: anObject

	newPasswordEntry := anObject.! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:39'!
newPasswordRepeatEntry

	^ newPasswordRepeatEntry! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:39'!
newPasswordRepeatEntry: anObject

	newPasswordRepeatEntry := anObject.! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 14:47'!
ok

	self newPasswordEntry accept.
	self newPasswordRepeatEntry accept.
	self model accept.
	super ok.! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/31/2009 12:02'!
okButton

	okButton ifNil: [
		okButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Ok'
			help: 'Saves your new password'.
		okButton isDefault: true].
	^ okButton! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:57'!
okButton: anObject

	okButton := anObject.! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:57'!
oldPasswordEntry: anObject

	oldPasswordEntry := anObject.! !

XpfDialog subclass: #XpfDeveloperChooser
	instanceVariableNames: 'okButton cancelButton developerDropList result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfDeveloperChooser class methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 18:09'!
for: aXpfTask

	^self new model: aXpfTask! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
cancelButton

	cancelButton ifNil: [
		cancelButton := UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Cancel'
		help: 'Close window'].
	^ cancelButton! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfDeveloperChooser methodsFor: 'user interface helper' stamp: 'SR 4/12/2009 17:36'!
createDeveloperDropList: myModel

	self developerDropList: (UITheme current 
		newDropListIn: self
		for: myModel projectsModel
		list: #list
		getSelected: #selectionIndex
		setSelected: #selectionIndex:
		getEnabled: nil
		useIndex: true
		help: 'Enter project id').
	self developerDropList minWidth: 200.
	^ self projectDropList! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:02'!
developerDropList

	developerDropList ifNil: [
		self developerDropList: (UITheme current 
			newDropListIn: self
			for: XpfDeveloperChooserModel new
			list: #list
			getSelected: #selectionIndex
			setSelected: #selectionIndex:
			getEnabled: nil
			useIndex: true
			help: 'Enter developer').
		self developerDropList minWidth: 200].
	^ developerDropList! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:38'!
developerDropList: anObject

	developerDropList := anObject.! !

!XpfDeveloperChooser methodsFor: 'initialization' stamp: 'SR 4/12/2009 17:53'!
initialize

	| |
	super initialize.
	self
		buttons: {self okButton. self cancelButton};
		contentMorph: self initializeUserInterface;
		addGrips;
		title: 'Specify Co-Developer'.! !

!XpfDeveloperChooser methodsFor: 'initialization' stamp: 'SR 4/12/2009 17:40'!
initializeUserInterface

	^ self createCol: {
		self createRow: {
			self createLabel: 'Developer:'.	self developerDropList}}! !

!XpfDeveloperChooser methodsFor: 'actions' stamp: 'SR 4/12/2009 18:10'!
model: aXpfTask

	super model: aXpfTask.
	self developerDropList model developerList: (aXpfTask project developers).! !

!XpfDeveloperChooser methodsFor: 'actions' stamp: 'SR 4/12/2009 18:11'!
ok

	self result: self developerDropList model developer.
	
	^ super ok! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:38'!
okButton

	okButton ifNil: [
		okButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Ok'
			help: 'Confirm Developer'.
		okButton isDefault: true].
	^ okButton! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
okButton: anObject

	okButton := anObject.! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
result

	^ result! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
result: anObject

	result := anObject.! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:25'!
createCol: someElements

	^ UITheme current newColumnIn: self for: someElements! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:25'!
createHFiller

	^ (UITheme current newToolSpacerIn: self) hResizing: #spaceFill! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createHSeparator

	^ UITheme current newSeparatorIn: self! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createLabel: aString

	^ UITheme current
		newLabelIn: self
		label: aString! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createRow: someElements

	^ UITheme current newRowIn: self for: someElements! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createVFiller

	^ (UITheme current newToolSpacerIn: self) vResizing: #spaceFill! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createVSeparator

	^ (UITheme current newSeparatorIn: self) hResizing: #rigid; vResizing: #spaceFill! !

!XpfDialog methodsFor: 'initialization' stamp: 'topa 3/6/2009 14:53'!
initializeUserInterface: aModel

	self subclassResponsibility.! !

XpfDialog subclass: #XpfLogin
	instanceVariableNames: 'loginEntry passwordEntry connectButton cancelButton result serverEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfLogin methodsFor: 'accessing' stamp: 'SR 3/19/2009 19:27'!
cancelButton

	cancelButton ifNil: [
		cancelButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #cancel
			arguments: nil
			getEnabled: nil
			label: 'Cancel'
			help: 'Close login window'].
	^ cancelButton! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:50'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfLogin methodsFor: 'accessing' stamp: 'SR 3/19/2009 19:33'!
connectButton

	connectButton ifNil: [
		connectButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Connect'
			help: 'Try to connect to server'.
		connectButton isDefault: true].
	^ connectButton! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:50'!
connectButton: anObject

	connectButton := anObject.! !

!XpfLogin methodsFor: 'user interface' stamp: 'topa 3/6/2009 14:51'!
createLoginEntryFor: myModel

	self loginEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #login
		set: #login:
		class: String
		getEnabled: nil
		help: 'Enter login') maxLength: 100).
	^ self loginEntry! !

!XpfLogin methodsFor: 'user interface' stamp: 'topa 3/6/2009 14:51'!
createPasswordEntryFor: myModel

	self passwordEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #password
		set: #password:
		class: String
		getEnabled: nil
		help: 'Enter password') maxLength: 100).
	self passwordEntry textMorph font: (StrikeFont passwordFontSize: 12).
	^ self passwordEntry! !

!XpfLogin methodsFor: 'user interface' stamp: 'topa 4/3/2009 16:37'!
createServerEntryFor: myModel

	self serverEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #server
		set: #server:
		class: String
		getEnabled: nil
		help: 'Enter the hostname of the server.') maxLength: 100).
	^ self serverEntry minWidth: 200! !

!XpfLogin methodsFor: 'initialization' stamp: 'SR 3/19/2009 19:29'!
initialize

	| myModel |
	super initialize.
	
	myModel := XpfLoginModel new.
	self
		buttons: {self connectButton. self cancelButton};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Login'.! !

!XpfLogin methodsFor: 'initialization' stamp: 'topa 4/3/2009 16:38'!
initializeUserInterface: myModel

	^ self createCol: {
		self createRow: {
			self createLabel: 'Server:'.
			self createServerEntryFor: myModel.}.
		self createHSeparator.
		self createRow: {
			self createLabel: 'Login:'.
			self createLoginEntryFor: myModel}.
		self createRow: {
			self createLabel: 'Password:'.
			self createPasswordEntryFor: myModel}}! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:51'!
loginEntry

	^ loginEntry! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:51'!
loginEntry: anObject

	loginEntry := anObject! !

!XpfLogin methodsFor: 'initialization' stamp: 'topa 4/3/2009 16:38'!
ok

	self serverEntry accept.
	self loginEntry accept.
	self passwordEntry accept.
			
	self result: self model connectString.
	^ super ok! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:52'!
passwordEntry

	^ passwordEntry! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:52'!
passwordEntry: anObject

	passwordEntry := anObject.! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:52'!
result

	^ result! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:52'!
result: anObject

	result := anObject.! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:36'!
serverEntry

	^ serverEntry! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:36'!
serverEntry: anObject

	serverEntry := anObject.! !

XpfDialog subclass: #XpfProjectChooser
	instanceVariableNames: 'okButton cancelButton changePasswordButton projectDropList result passwordChangeDialog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfProjectChooser methodsFor: 'accessing' stamp: 'SR 3/19/2009 19:32'!
cancelButton

	cancelButton ifNil: [
		cancelButton := UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Cancel'
		help: 'Close window'].
	^ cancelButton! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'topa 3/6/2009 17:42'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 3/31/2009 13:11'!
changePasswordButton

	changePasswordButton ifNil: [
		changePasswordButton := UITheme current 
			newButtonIn: self
			for: [self openModal: self passwordChangeDialog]
			getState: nil
			action: #value
			arguments: nil
			getEnabled: nil
			label: 'Change Password'
			help: 'Change your password'].
	^ changePasswordButton! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 3/31/2009 13:07'!
changePasswordButton: anObject

	changePasswordButton := anObject.! !

!XpfProjectChooser methodsFor: 'user interface helper' stamp: 'SR 3/10/2009 14:01'!
createProjectDropList: myModel

	self projectDropList: (UITheme current 
		newDropListIn: self
		for: myModel projectsModel
		list: #list
		getSelected: #selectionIndex
		setSelected: #selectionIndex:
		getEnabled: nil
		useIndex: true
		help: 'Enter project id').
	self projectDropList minWidth: 200.
	^ self projectDropList! !

!XpfProjectChooser methodsFor: 'initialization' stamp: 'mt 3/31/2009 13:12'!
initialize

	| myModel |
	super initialize.
	
	myModel := XpfProjectChooserModel new.
	
	self
		buttons: {self okButton. self cancelButton. self changePasswordButton};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Specify Project'.! !

!XpfProjectChooser methodsFor: 'initialization' stamp: 'SR 3/10/2009 13:54'!
initializeUserInterface: myModel

	^ self createCol: {
		self createRow: {
			self createLabel: 'Project:'.	self createProjectDropList: myModel}}! !

!XpfProjectChooser methodsFor: 'actions' stamp: 'SR 3/10/2009 14:00'!
ok

	self result: self model project.
	
	^ super ok! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'SR 3/19/2009 19:33'!
okButton

	okButton ifNil: [
		okButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Ok'
			help: 'Confirm Project Id'.
		okButton isDefault: true].
	^ okButton! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'topa 3/6/2009 17:42'!
okButton: anObject

	okButton := anObject.! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 3/31/2009 13:06'!
passwordChangeDialog

	^ passwordChangeDialog! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 3/31/2009 13:06'!
passwordChangeDialog: anObject

	passwordChangeDialog := anObject.! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'SR 3/10/2009 13:49'!
projectDropList

	^ projectDropList! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'SR 3/10/2009 13:49'!
projectDropList: anObject

	projectDropList := anObject.! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'topa 3/6/2009 17:46'!
result

	^ result! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'topa 3/6/2009 17:46'!
result: anObject

	result := anObject.! !

SimpleHierarchicalListMorph subclass: #XpfIterationTreeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfIterationTreeMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 14:53'!
for: anXpfIteration

	| result |
	result := self
		on: (XpfIterationTreeModel new iteration: anXpfIteration)
		list: #rootItems
		selected: nil
		changeSelected: nil
		menu: nil
		keystroke: nil.
	^ result model addDependent: result expandRoots
! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:06'!
backupExpandedState

	| backup |
	backup := Dictionary new.
	scroller submorphsDo: [:m |
		m complexContents hasXpfModel ifTrue: [
			backup at: m complexContents model restUri put: m isExpanded]].
	^ backup.! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:49'!
collapseAll
	"Expand all of the roots!!"
	
	self roots do: [:m |
		self collapseAll: m].
	self adjustSubmorphPositions! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:50'!
collapseAll: aMorph
	| allChildren |
	aMorph isExpanded ifTrue: [aMorph toggleExpandedState].
	allChildren _ OrderedCollection new: 10.
	aMorph recursiveAddTo: allChildren.
	allChildren do: [:each | 
		(each canExpand and: [each isExpanded])
			ifTrue: [self collapseAll: each]].
! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 10:27'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:52'!
restoreExpandedState: aDictionary

	scroller submorphsDo: [:m |
		m complexContents hasXpfModel ifTrue: [
			(aDictionary includesKey: m complexContents model restUri)
				ifTrue: [
					m isExpanded = (aDictionary at: m complexContents model restUri) ifFalse: [m toggleExpandedState]]]].! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:50'!
update: aSymbol

	aSymbol = #userStories ifTrue: [ | backup |
		backup := self backupExpandedState.
		self
			list: self getList;
			collapseAll;
			expandRoots;
			restoreExpandedState: backup;
			adjustSubmorphPositions].
	super update: aSymbol.! !

RestProxyObject subclass: #XpfProxyObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Proxies'!

!XpfProxyObject methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 15:38'!
currentUser

	| userResponse |
	userResponse := RestSocket get: self repository url asString , 'info'. 
	userResponse isOk
		ifTrue: [^ self repository getObject: userResponse content]
		ifFalse: [^ nil]! !

!XpfProxyObject methodsFor: 'as yet unclassified' stamp: 'mig 4/3/2009 15:29'!
revision

	^ properties isNil
		ifTrue: [nil]
		ifFalse: [super revision]! !

ImageMorph subclass: #XpfDeleteMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfDeleteMorph methodsFor: 'layout' stamp: 'mfp 3/19/2009 17:15'!
acceptDroppingMorph: aMorph event: evt 

	aMorph isUserStoryMorph
		ifTrue: [self performActionWithUserStory: aMorph model. aMorph delete].
	aMorph isTaskMorph
		ifTrue: [self performActionWithTask: aMorph model. aMorph delete].
! !

!XpfDeleteMorph methodsFor: 'testing' stamp: 'mfp 3/19/2009 17:05'!
acceptsTasks

	^ true! !

!XpfDeleteMorph methodsFor: 'testing' stamp: 'topa 3/11/2009 15:46'!
acceptsUserStories

	^ true! !

!XpfDeleteMorph methodsFor: 'initialization' stamp: 'topa 3/19/2009 14:38'!
initialize

	super initialize.
	self image: TrashCanMorph initializeTrashPic.! !

!XpfDeleteMorph methodsFor: 'accessing' stamp: 'topa 3/19/2009 14:38'!
model

	^ model! !

!XpfDeleteMorph methodsFor: 'accessing' stamp: 'topa 3/19/2009 14:38'!
model: anObject

	model := anObject.! !

!XpfDeleteMorph methodsFor: 'event handling' stamp: 'mig 4/3/2009 14:11'!
performActionWithTask: anXpfEntity

	self model tasks remove: anXpfEntity.
	anXpfEntity delete.! !

!XpfDeleteMorph methodsFor: 'event handling' stamp: 'topa 4/6/2009 16:38'!
performActionWithUserStory: anXpfEntity

	"self model userStories remove: anXpfEntity."
	anXpfEntity delete.! !

!XpfDeleteMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 3/19/2009 17:07'!
wantsDroppedMorph: aMorph event: evt

	^ aMorph isUserStoryMorph | aMorph isTaskMorph! !

PasteUpMorph subclass: #XpfTaskListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTaskListMorph methodsFor: 'updating' stamp: 'mig 3/21/2009 16:50'!
acceptDroppingMorph: aMorph event: evt 

	(aMorph isTaskMorph and: [self model tasks noneSatisfy: [:a | a id = aMorph model id]])
			ifTrue: [
				aMorph model userStories first removeTask: aMorph model.
				self model addTask: aMorph model.
			].
	super acceptDroppingMorph: aMorph event: evt.! !

!XpfTaskListMorph methodsFor: '*xpf-client' stamp: 'mfp 3/19/2009 14:41'!
acceptsTasks

	^ true! !

!XpfTaskListMorph methodsFor: 'initialization' stamp: 'SR 3/19/2009 21:57'!
createUserInterface

	self model tasks do: [:task |
		self addMorphBack: ((XpfTaskMorph forTask: task) width: self width -2)]! !

!XpfTaskListMorph methodsFor: 'initialization' stamp: 'mfp 3/19/2009 17:29'!
initialize

	super initialize.
	self		
		changeTableLayout;
		hResizing: #rigid;
		vResizing: #shrinkWrap;
		fillStyle: Color veryVeryLightGray;
		borderWidth: 0;
		listDirection: #topToBottom;
		layoutInset: 1;
		cellPositioning: #topLeft;
		cellInset: 4.! !

!XpfTaskListMorph methodsFor: 'layout' stamp: 'mfp 3/19/2009 17:32'!
layoutChanged

	self owner ifNotNil: 
		[self owner owner extent: 1@1 + self owner owner extent.
		self owner owner extent: -1@-1 + self owner owner extent].
	super layoutChanged.! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'mfp 3/19/2009 14:40'!
model: anXpfTaskCollection

	model := anXpfTaskCollection.
	self createUserInterface.
	self model addDependent: self.! !

!XpfTaskListMorph methodsFor: 'updating' stamp: 'mfp 3/19/2009 17:30'!
update: anObject

	self 
		removeAllMorphs;
		createUserInterface.
	super update: anObject.! !

!XpfTaskListMorph methodsFor: 'layout' stamp: 'mfp 3/19/2009 17:49'!
withScrollBars

	| scrollPane |
	scrollPane := ScrollPane new.
	scrollPane
		hResizing: #spaceFill;
		vResizing: #rigid;
		fillStyle: Color veryVeryLightGray;
		borderWidth: 0;
		alwaysShowHScrollBar: false;
		setProperty: #noHScrollBarPlease toValue:  true;
		alwaysShowVScrollBar: true.
	scrollPane scroller addMorph: self.
	^ scrollPane! !

PasteUpMorph subclass: #XpfUserStoryPoolMorph
	instanceVariableNames: 'userStoryAddMorph deleteMorph titleMorph scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryPoolMorph class methodsFor: 'contants' stamp: 'cs 3/18/2009 17:05'!
defaultGridSize

	^ 32@32! !

!XpfUserStoryPoolMorph class methodsFor: 'contants' stamp: 'mt 3/31/2009 15:39'!
for: anXpfIteration

	^ self new model: anXpfIteration! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'SR 4/7/2009 14:33'!
acceptDroppingMorph: aMorph event: evt 
	
	aMorph position: (self gridPoint: aMorph position).

	aMorph model deferCommit: [self positionDroppedMorph: aMorph].

	(aMorph isUserStoryMorph and: [self model userStories noneSatisfy: [:a | a id = aMorph model id]])
			ifTrue: [
				aMorph model iteration ifNotNil: [
					aMorph model iteration removeUserStory: aMorph model].				
				self model addUserStory: aMorph model].
	
	super acceptDroppingMorph: aMorph event: evt.! !

!XpfUserStoryPoolMorph methodsFor: 'testing' stamp: 'cs 3/10/2009 16:14'!
acceptsUserStories

	^ true! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'cs 3/11/2009 15:44'!
addUserStoryMorph: anXpfUserStoryMorph

	^ self addMorph:
		"Places new UserStories in the top left corner with 5 indent"
		(anXpfUserStoryMorph topLeft: self topLeft + (self submorphCount + 1 * 5 asPoint))! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/9/2009 13:08'!
adjustLayoutBounds
	"Adjust the receivers bounds depending on the resizing strategy imposed"
	| hFit vFit box myExtent extent |
	
	hFit := self hResizing.
	vFit := self vResizing.
	
	(hFit = #rigid and: [vFit = #rigid]) ifTrue: [^self].
	
	box := self layoutBounds.
	myExtent := box extent.
	extent := self submorphBounds corner - box origin.
	
	hFit = #growWrap ifTrue: [
		(extent x > owner owner bounds width)
			ifFalse: [hFit := #spaceFill]
			ifTrue: [hFit := #shrinkWrap]].
	
	vFit = #growWrap ifTrue: [
		(extent y > owner owner bounds height)
			ifFalse: [vFit := #spaceFill]
			ifTrue: [vFit := #shrinkWrap]].
		
	hFit == #shrinkWrap ifTrue:[myExtent := extent x @ myExtent y].
	hFit == #spaceFill ifTrue: [myExtent := owner owner bounds width @ myExtent y].
	
	vFit == #shrinkWrap ifTrue:[myExtent := myExtent x @ extent y].
	vFit == #spaceFill ifTrue: [myExtent := myExtent x @ owner owner bounds height].
	
	"Make sure we don't get smaller than minWidth/minHeight"
	myExtent x < self minWidth ifTrue:[
		myExtent := (myExtent x max: 
			(self minWidth - self bounds width + self layoutBounds width)) @ myExtent y].
	myExtent y < self minHeight ifTrue:[
		myExtent := myExtent x @ (myExtent y max:
			(self minHeight - self bounds height + self layoutBounds height))].
	self layoutBounds: (box origin extent: myExtent).! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/9/2009 13:55'!
adjustLeft: aMorph

	^ 0 max: ((aMorph left - self left) * 10000) asInteger! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/9/2009 13:55'!
adjustTop: aMorph

	^ 0 max: ((aMorph top - self top) * 10000) asInteger! !

!XpfUserStoryPoolMorph methodsFor: 'initialization' stamp: 'mt 3/31/2009 16:31'!
buildDeleteMorph
	
	self deleteMorph ifNotNil: 
		[self removeMorph: self deleteMorph].
	
	self deleteMorph: (XpfDeleteMorph new
		bottomLeft: 4@XpfClient defaultHeight + self topLeft;
		model: self model;
		yourself).
	self addMorph: self deleteMorph.! !

!XpfUserStoryPoolMorph methodsFor: 'initialization' stamp: 'mt 3/31/2009 16:31'!
buildUserStoryAddMorph
	
	self userStoryAddMorph ifNotNil: [
		self removeMorph: self userStoryAddMorph].
	
	self userStoryAddMorph: (XpfUserStoryAddMorph new
		topRight: XpfClient defaultWidth@5 + self topLeft;
		model: self model;
		yourself).
	self addMorph: self userStoryAddMorph.! !

!XpfUserStoryPoolMorph methodsFor: 'initialization' stamp: 'SR 3/21/2009 15:25'!
buildUserStorySubmorphs

	self model ifNotNil: [
		self model userStories do: [ :userStory| 
			self addUserStoryMorph: (XpfUserStoryMorph forUserStory: userStory)]]! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'topa 3/19/2009 14:41'!
deleteMorph

	^ deleteMorph! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mfp 3/19/2009 18:07'!
deleteMorph: aMorph

	deleteMorph := aMorph.! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/9/2009 13:54'!
doLayoutIn: layoutBounds
	"Beware of fullBounds!!"

	super doLayoutIn: layoutBounds.
	self userStorySubmorphs do: [:morph |
		morph position: (self gridPoint:
			((morph model positionX / 10000.0) + layoutBounds left) @
			((morph model positionY / 10000.0) + layoutBounds top))].
		
	self deleteMorph ifNotNil: [
		self deleteMorph
			left: {self fullBounds right. layoutBounds left + 5} min;
			top: {self fullBounds bottom. layoutBounds top + layoutBounds height - self deleteMorph height - 5} min].

	self userStoryAddMorph ifNotNil: [
		self userStoryAddMorph
			left: {self fullBounds right. layoutBounds topRight x - (self userStoryAddMorph width + 7)} min;
			top: {self fullBounds bottom. layoutBounds top + 5} min]
		
! !

!XpfUserStoryPoolMorph methodsFor: 'initialization' stamp: 'mt 4/3/2009 09:46'!
initialize

	super initialize.

	self
		borderWidth: 0;
		useRoundedCorners;
		fillStyle: Color veryVeryLightGray;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		enableDragNDrop;
		gridModulus: self class defaultGridSize;
		griddingOnOff;
		addMorph: self titleMorph.! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/3/2009 09:48'!
model: aXpfIteration

	aXpfIteration ifNil: [^ self].

	model := aXpfIteration.
	
	self removeAllMorphsIn: self userStorySubmorphs.
	self buildUserStorySubmorphs.
	self model addDependent: self.
	self titleMorph contents: self model title.! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'mfp 4/2/2009 14:40'!
positionDroppedMorph: aMorph

		aMorph model
			positionX: (self adjustLeft: aMorph);
			positionY: (self adjustTop: aMorph).
! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'SR 4/10/2009 11:58'!
scrollPane

	^ scrollPane! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'SR 4/10/2009 11:58'!
scrollPane: anObject

	scrollPane := anObject! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/3/2009 09:50'!
titleMorph

	titleMorph ifNil: [self titleMorph: '' asText asMorph. self titleMorph lock].
	^ titleMorph! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/3/2009 09:19'!
titleMorph: anObject

	titleMorph := anObject! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/10/2009 12:04'!
toggleShow

	self scrollPane isNil
		ifTrue: [self
			visible: self visible not;
			disableTableLayout: self visible not]
		ifFalse: [self scrollPane toggleShow].! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'topa 3/9/2009 15:34'!
userStoryAddMorph

	^ userStoryAddMorph! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'topa 3/9/2009 15:42'!
userStoryAddMorph: anObject

	userStoryAddMorph := anObject.! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/2/2009 15:23'!
userStorySubmorphs

	^ self submorphs select: [:aMorph| aMorph isUserStoryMorph]! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 3/19/2009 17:38'!
wantsDroppedMorph: aMorph event: evt

	^ aMorph isUserStoryMorph! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/10/2009 11:58'!
withScrollBars

	self scrollPane: XpfScrollPane new.
	(self scrollPane)
		scroller addMorph: self;
		maxCellSize: 1050 @ 1050.
	self extent: 1024 @ 1024;
		vResizing: #rigid;
		hResizing: #rigid.
	^ self scrollPane! !

ScrollPane subclass: #XpfScrollPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfScrollPane methodsFor: 'as yet unclassified' stamp: 'SR 4/9/2009 13:57'!
extent: newExtent

	super extent: newExtent.
	self scroller submorphsDo: [:each | each adjustLayoutBounds].
	^self.! !

!XpfScrollPane methodsFor: 'as yet unclassified' stamp: 'SR 4/10/2009 12:05'!
toggleShow

	self
		visible: self visible not;
		disableTableLayout: self visible not! !

RestProxyCollection subclass: #XpfProxyCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Proxies'!

!XpfProxyCollection methodsFor: 'as yet unclassified' stamp: 'mig 4/3/2009 15:32'!
revision

	| shortRestUri |
	shortRestUri := String new.
	(self restUri findTokens: $/) allButLast
		do: [:each | shortRestUri := shortRestUri, each]
		separatedBy: [shortRestUri := shortRestUri, '/'].
	shortRestUri ifEmpty: [^ 0]. "I am a collection with no parent therefore I have no revision. 0 means always update"
	^ (self repository getObject: shortRestUri) revision! !

RestProxyRepository subclass: #XpfProxyRepository
	instanceVariableNames: 'updateProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Proxies'!

!XpfProxyRepository class methodsFor: 'constants' stamp: 'mig 4/3/2009 15:32'!
proxyCollectionClass

	^ XpfProxyCollection! !

!XpfProxyRepository class methodsFor: 'constants' stamp: 'mig 4/3/2009 15:26'!
proxyObjectClass

	^ XpfProxyObject! !

!XpfProxyRepository class methodsFor: 'constants' stamp: 'mig 4/3/2009 10:56'!
reloadInterval
	"reload interval in seconds"
	
	^ 10! !

!XpfProxyRepository methodsFor: 'add-remove' stamp: 'cs 3/18/2009 11:55'!
addProject: aProject 

	^ self getAllProjects addNew: aProject! !

!XpfProxyRepository methodsFor: 'add-remove' stamp: 'cs 3/18/2009 11:56'!
addUser: aUser 

	^ self getAllUsers addNew: aUser! !

!XpfProxyRepository methodsFor: 'updating' stamp: 'mig 4/1/2009 16:51'!
changesUrl
	
	^ (self url asString, '/changes') asUrl! !

!XpfProxyRepository methodsFor: 'accessing' stamp: 'mig 3/13/2009 15:58'!
getAllProjects

	^ self getCollection: '/projects/'! !

!XpfProxyRepository methodsFor: 'accessing' stamp: 'mig 3/13/2009 15:58'!
getAllUsers

	^ self getCollection: '/users/'! !

!XpfProxyRepository methodsFor: 'private' stamp: 'mig 4/3/2009 10:55'!
pvtUpdateProcess

	^ updateProcess! !

!XpfProxyRepository methodsFor: 'private' stamp: 'mig 4/3/2009 10:54'!
pvtUpdateProcess: anObject

	updateProcess := anObject.! !

!XpfProxyRepository methodsFor: 'updating' stamp: 'mig 4/1/2009 18:01'!
reload
	"Sends the URIs of all loaded proxies to the server and retrieves the updates"

	| response |
	response := RestSocket postDocumentFromUrl: self changesUrl request: '' content: 
		(Json render: (Dictionary newFrom:
			((self cache associations
				reject: [:assoc | assoc value revision isNil])
				collect: [:assoc | assoc key -> assoc value revision]))).
	response isOk
		ifTrue: [
			(Json readFrom: (response content readStream))
				do: [:uri | (self cache at: uri) reload]]
		ifFalse: [self inform: response content].! !

!XpfProxyRepository methodsFor: 'initialization' stamp: 'mig 4/3/2009 11:14'!
startUpdating
	
	self pvtUpdateProcess ifNil: [	self pvtUpdateProcess: self updater fork].! !

!XpfProxyRepository methodsFor: 'as yet unclassified' stamp: 'mig 4/3/2009 11:15'!
stopUpdating

	self pvtUpdateProcess ifNotNil: [
		self pvtUpdateProcess terminate.
		self pvtUpdateProcess: nil].
! !

!XpfProxyRepository methodsFor: 'updating' stamp: 'mig 4/3/2009 10:58'!
updater

	^ [[(Delay forSeconds: self class reloadInterval) wait. 
		self reload]
		repeat]! !

StandardWindow subclass: #XpfClient
	instanceVariableNames: 'sidebar mainPanel currentPool futurePool historyPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfClient class methodsFor: 'defaults' stamp: 'mfp 3/19/2009 18:01'!
defaultHeight

	^ 480! !

!XpfClient class methodsFor: 'defaults' stamp: 'mfp 3/19/2009 18:01'!
defaultWidth

	^ 640! !

!XpfClient class methodsFor: 'user interface' stamp: 'SR 4/10/2009 19:05'!
open
	
	| instance login |
	[login := XpfLoginProcessor new.
	
	Utilities informUserDuring: [:bar |
		#(model open) do: [:step |
			step = #model ifTrue: [
				bar value: 'Preparing data...'.
				instance := self new model: login project].
			step = #open ifTrue: [
				bar value: 'Opening client...'.
				instance openInWorld]]].

	^ instance]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfClient methodsFor: 'initialization' stamp: 'cs 4/6/2009 17:45'!
buttonBar

	^ self newRow: {
		self createAddIterationButton.
		self createToggleHistoryButton.
		self newToolSpacer hResizing: #spaceFill}! !

!XpfClient methodsFor: 'as yet unclassified' stamp: 'cs 4/6/2009 17:43'!
createAddIterationButton

	^ self newButtonFor: self
		getState: nil
		action: #createIteration
		arguments: nil
		getEnabled: nil
		label: '+'
		help: 'Add new iteration'! !

!XpfClient methodsFor: 'as yet unclassified' stamp: 'mt 4/2/2009 11:17'!
createFirstIteration

	| result |
	result := self textEntry: 'No iteration found. Choose a name for the first iteration:' title: 'Add initial iteration'. 	
	^ self model addNewIteration: (Dictionary newFrom: {'title' -> (result ifNil: ['New Iteration'])})! !

!XpfClient methodsFor: 'as yet unclassified' stamp: 'mt 4/2/2009 11:16'!
createIteration

	| result |
	result := self textEntry: 'Choose a name for the iteration:' title: 'Add iteration'. 
	
	result ifNil: [^ self].
	
	^ self model addNewIteration: (Dictionary newFrom: {'title' -> result})! !

!XpfClient methodsFor: 'as yet unclassified' stamp: 'cs 4/6/2009 17:45'!
createToggleHistoryButton

	^ self newButtonFor: self
		getState: nil
		action: #toggleHistory
		arguments: nil
		getEnabled: nil
		label: 'H'
		help: 'Toggle visibilty of history panel'! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 3/31/2009 16:51'!
currentPool

	^ currentPool! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 3/31/2009 15:44'!
currentPool: anXpfUserStoryPoolMorph

	currentPool := anXpfUserStoryPoolMorph! !

!XpfClient methodsFor: 'submorphs-add/remove' stamp: 'mig 4/3/2009 11:15'!
delete

	self model repository stopUpdating.
	super delete.
! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 3/31/2009 16:51'!
futurePool

	^ futurePool! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 3/31/2009 15:45'!
futurePool: anXpfUserStoryPoolMorph

	futurePool := anXpfUserStoryPoolMorph! !

!XpfClient methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:27'!
historyPanel

	historyPanel ifNil:
		[historyPanel := XpfHistoryMorph forProject: self model].
	^ historyPanel! !

!XpfClient methodsFor: 'initialization' stamp: 'SR 4/9/2009 11:13'!
initialize

	super initialize.	
	self
		addMorph: (self newDialogPanel listDirection: #leftToRight)
		frame: (0@0 corner: 1@1);
		extent: self class defaultWidth @ self class defaultHeight;
		futurePool: (XpfUserStoryPoolMorph new
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			fillStyle: Color white);
		currentPool: (XpfUserStoryPoolMorph new
			hResizing: #spaceFill;
			vResizing: #spaceFill);
		sidebar: XpfIterationSidebarMorph new.! !

!XpfClient methodsFor: 'initialization' stamp: 'cs 4/6/2009 17:43'!
initializeUserInterface

	self paneMorphs first
		addMorphBack: (self newColumn: {
			(self newRow: {
				(self newColumn: {self sidebar. self buttonBar}) hResizing: #shrinkWrap.
				self mainPanel}) vResizing: #spaceFill; yourself.
			self historyPanel})! !

!XpfClient methodsFor: 'as yet unclassified' stamp: 'SR 4/9/2009 13:41'!
mainPanel
	
	mainPanel ifNil: [self mainPanel: (self newColumn: {
		(self futurePool withScrollBars)
			spaceFillWeight: 1;
			vResizing: #spaceFill;
			hResizing: #spaceFill.
		(self currentPool withScrollBars)
			spaceFillWeight: 3;
			vResizing: #spaceFill;
			hResizing: #spaceFill}).
		mainPanel maxCellSize: 1050@1050].
	^ mainPanel! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 3/31/2009 17:42'!
mainPanel: anObject

	mainPanel := anObject.! !

!XpfClient methodsFor: 'accessing' stamp: 'SR 4/7/2009 11:54'!
model: anXpfProject

	super model: anXpfProject.
	self currentPool model: (anXpfProject iterations detect: [:it | it isXpfFutureIteration not] ifNone: [self createFirstIteration]).
	self futurePool model: (anXpfProject iterations detect: [:it | it isXpfFutureIteration] ifNone: []).
	
	self currentPool
		buildDeleteMorph;
		buildUserStoryAddMorph.
		
	self
		title: anXpfProject title;
		initializeUserInterface.

	(self sidebar)
		addDependent: self;
		model: self model.
	self model isRestProxy ifTrue:
		[anXpfProject repository startUpdating].! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 3/31/2009 17:49'!
selectIteration: anXpfIteration

	self currentPool model: anXpfIteration.! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 4/1/2009 13:53'!
sidebar

	^ sidebar! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 3/31/2009 17:42'!
sidebar: anXpfIterationSidebarMorph

	sidebar := anXpfIterationSidebarMorph.! !

!XpfClient methodsFor: 'accessing' stamp: 'SR 4/10/2009 12:01'!
toggleFuturePool

	self futurePool toggleShow.! !

!XpfClient methodsFor: 'as yet unclassified' stamp: 'cs 4/6/2009 17:47'!
toggleHistory

	self historyPanel
		visible: self historyPanel visible not;
		disableTableLayout: self historyPanel visible not.! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 3/31/2009 17:35'!
update: aSymbol

	aSymbol = #toggleFuturePoolRequested ifTrue: [self toggleFuturePool].
	
	super update: aSymbol.! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 3/31/2009 17:48'!
update: aSymbol with: anObject

	aSymbol = #iterationSelected ifTrue: [self selectIteration: anObject].
	
	super update: aSymbol with: anObject.! !

!Morph methodsFor: '*xpf-client' stamp: 'mfp 3/19/2009 14:43'!
acceptsTasks

	^ false! !

!Morph methodsFor: '*xpf-client' stamp: 'cs 3/10/2009 16:13'!
acceptsUserStories

	^ false! !

!Morph methodsFor: '*xpf-client' stamp: 'mfp 3/19/2009 16:14'!
isEntityMorphContent

	^ false! !

!Morph methodsFor: '*xpf-client' stamp: 'topa 3/19/2009 14:53'!
isTaskMorph

	^ false! !

!Morph methodsFor: '*xpf-client' stamp: 'topa 3/3/2009 23:50'!
isUserStoryMorph

	^ false! !

!Morph methodsFor: '*xpf-client' stamp: 'mfp 3/19/2009 16:15'!
isXpfUserStoryTitleContent

	^ false! !
